program CPConsole;

uses
  Forms,
  oInterfaces,
  oCP_Exceptions,
  uCP_GUI,
  SysUtils,
  Dialogs,
  Controls,
  fMain in 'fMain.pas' {frmMain},
  mEditInstrument in 'mEditInstrument.pas' {fraEditInstrument: TFrame},
  mEditProcedure in 'mEditProcedure.pas' {fraEditProcedure: TFrame},
  mEditFlowsheet in 'mEditFlowsheet.pas' {fraEditFlowsheet: TFrame},
  mEditObservationViewFilter in 'mEditObservationViewFilter.pas' {fraEditObservationViewFilter: TFrame},
  mEditFlowsheetPage in 'mEditFlowsheetPage.pas' {fraEditFlowsheetPage: TFrame},
  mEditMappingTable in 'mEditMappingTable.pas' {fraEditMappingTable: TFrame},
  fTester in 'fTester.pas' {frmTester},
  fLookup in '..\TLookupFrame\fLookup.pas' {frmLookup},
  mLookup in '..\TLookupFrame\mLookup.pas' {fraLookup: TFrame},
  mSearch in 'mSearch.pas' {fraSearch: TFrame},
  fXMLExport in 'fXMLExport.pas' {frmXMLExport},
  fXMLImport in 'fXMLImport.pas' {frmXMLImport},
  mEditFlowsheetView in 'mEditFlowsheetView.pas' {fraEditFlowsheetView: TFrame},
  mEditBackgroundTask in 'mEditBackgroundTask.pas' {fraEditBackgroundTask: TFrame},
  mEditGatewayConfig in 'mEditGatewayConfig.pas' {fraEditGatewayConfig: TFrame},
  mEditCPParameters in 'mEditCPParameters.pas' {fraEditCPParameters: TFrame},
  fEditFlowsheetPage in 'fEditFlowsheetPage.pas' {frmEditFlowsheetPage},
  fEditViewTerm in 'fEditViewTerm.pas' {frmEditViewTerm},
  mEditADTConfig in 'mEditADTConfig.pas' {fraEditADTConfig: TFrame},
  fAddADTTarget in 'fAddADTTarget.pas' {frmAddADTTarget},
  mEditShift in 'mEditShift.pas' {fraEditShift: TFrame},
  fUpdateTerminology in 'fUpdateTerminology.pas' {frmUpdateTerminology},
  mEditFlowsheetTotal in 'mEditFlowsheetTotal.pas' {fraEditFlowsheetTotal: TFrame},
  fAccessControlList in 'fAccessControlList.pas' {frmAccessControlList},
  mEditSchedule in 'mEditSchedule.pas' {fraEditSchedule: TFrame},
  fEditNotificationLists in 'fEditNotificationLists.pas' {frmEditNotificationLists},
  u508Dialogs,
  fImageList in '..\CP Flowsheets\fImageList.pas' {frmImageList},
  U_HelpMGR in 'U_HelpMGR.pas',
  Vcl.Themes,
  Vcl.Styles;

{$R *.res}

begin
  Application.Initialize;
  Application.Title := 'CP Console';

  MyVistALogin := NewDBConnection_VistA;
  try
    try
      MyVistALogin.Connect([GetCommandLineValue('SERVER'), GetCommandLineValue('PORT'), '', 'MD CLIO']);

      MyVistALogin.QueryInterface(IDBConnection, MyDBConnection);
      MyUser := NewUser('', MyDBConnection);
      MyCPParameters := NewCPParameters(MyVistALogin);
      MyCPParameters.Load;

      if MyUser.HasRole('MD READ-ONLY') then
        raise Exception.Create('You currently have key "MD READ-ONLY" assigned to your account.  You may not log on to CP Console while you have this key.');

      if not MyCPParameters.getApplicationRegistered then
        MessageDlg508(
          Format('Unable to start %s.' + #13 + #13 +
          'This version ''%s'' is not the correct version.' + #13 + #13 +
          'Your VistA connection to %s shows' + #13 +
          '''%s'' as the required version.',
          [Application.ExeName, MyCPParameters.getCurrentApplicationVersion, MyVistALogin.getDescription, MyCPParameters.getRegisteredApplicationVersion]),
          mtError, [mbOk], 0)
  {$IFDEF DEBUG}
        ;
        if (DebugHook <> 0) or (MessageDlg508('This DEBUG build ignores the version control' + #13#13 +
          'DO NOT USE IT IN PRODUCTION ACCOUNTS',
          mtInformation, [mbOK, mbCancel],0) = mrOK) then
  {$ELSE}
      else
  {$ENDIF}
        begin
          (*
          MyServerOffset := GetServerTimeOffset(MyVistALogin);

          case MyServerOffset of
            -1: raise Exception.Create('Unable to verify server date/time. Application is unable to proceed.');
            0..120: {within two minutes...who cares};
            121..300: MessageDlg('Workstation clock is off by '+IntToStr(MyServerOffset)+' seconds.',mtWarning,[mbOk],0);
          else
            raise Exception.CreateFmt('Workstation clock must be within 300 seconds of the server but it is off by %d seconds.',[MyServerOffset]);
          end;
          *)

          Application.CreateForm(TfrmMain, frmMain);
  Application.CreateForm(TfrmImageList, frmImageList);
  Application.Run;
        end;
    finally
      MyCPParameters := nil;
      MyUser := nil;
      MyDBConnection := nil;
      MyVistALogin := nil;
    end;
  except
    on E: Exception do
      MessageDlg508('Application is shutting down.' + #13 + #13 + 'Reason:' + #13 + E.Message, mtError, [mbOk], 0);
  end;

end.

