unit fAccessControlList;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  oInterfaces,
  oCPTypes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  StdCtrls,
  ActnList,
  ExtCtrls,
  Grids,
  ValEdit, VA508AccessibilityManager;

type
  TfrmAccessControlList = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    lbxUsers: TListBox;
    Button3: TButton;
    Button1: TButton;
    pnlPermissions: TPanel;
    rbtnReadOnly: TRadioButton;
    rbtnReadWrite: TRadioButton;
    rbtnReadWriteDelete: TRadioButton;
    rbtnFullControl: TRadioButton;
    Label1: TLabel;
    lblPermissions: TLabel;
    acList: TActionList;
    acAdd: TAction;
    acRemove: TAction;
    acUpdate: TAction;
    acRefresh: TAction;
    Button2: TButton;
    btnOK: TButton;
    Label2: TLabel;
    Label3: TLabel;
    lblID: TLabel;
    lblName: TLabel;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure acRefreshExecute(Sender: TObject);
    procedure lbxUsersClick(Sender: TObject);
    procedure acRemoveExecute(Sender: TObject);
    procedure acAddExecute(Sender: TObject);
    procedure PermissionChange(Sender: TObject);
    procedure acUpdateExecute(Sender: TObject);
  protected
    fItem: ICPConsoleItem;
    fPerson: IPerson;
    fPersonList: IInterfaceList;
  public
    { Public declarations }
  end;

procedure UpdateAccessControlList(aItem: ICPConsoleItem);

implementation

{$R *.dfm}

uses
  fPersonLookup,
  fMain;

procedure UpdateAccessControlList(aItem: ICPConsoleItem);
begin
  with TfrmAccessControlList.Create(Application) do
    try
      lblID.Font.Style := [fsBold];
      lblName.Font.Style := [fsBold];
      lblID.Caption := aItem.getID;
      lblName.Caption := aItem.getName;

      fItem := aItem;
      TInterfaceList.Create.GetInterface(IInterfaceList, fPersonList);
      acRefresh.Execute;
      ShowModal;
    finally
      Free;
    end;
end;

procedure TfrmAccessControlList.acAddExecute(Sender: TObject);
(*
var
  aPerson: IPerson;
*)
begin
  (*
  aPerson := LookupPerson(MyPersonService);
  if Assigned(aPerson) then
    MyCPService.ACLUpdate(fItem, aPerson, alReadOnly);
  acRefresh.Execute;
  *)
end;

procedure TfrmAccessControlList.acRefreshExecute(Sender: TObject);
(*
var
  aPerson: IPerson;
*)
begin
  (*
  MyCPService.ACLLoadList(fItem, lbxUsers.Items); {Load only the ACL records for this item}
  if MyUser.QueryInterface(IPerson, aPerson) = 0 then
    begin
      acAdd.Enabled := (MyCPService.ACLAccessLevel(fItem, aPerson) = alFullControl);
      acRemove.Enabled := (MyCPService.ACLAccessLevel(fItem, aPerson) = alFullControl);
      acUpdate.Enabled := False;
    end
  else
    begin
      acAdd.Enabled := False;
      acRemove.Enabled := False;
      acUpdate.Enabled := False;
    end;

  lbxUsersClick(Sender);
  *)
end;

procedure TfrmAccessControlList.acRemoveExecute(Sender: TObject);
(*
var
  aItem: ICPAccessControlListItem;
*)
begin
  (*
  if lbxUsers.ItemIndex > -1 then
    if lbxUsers.Items.Objects[lbxUsers.ItemIndex].GetInterface(ICPAccessControlListItem, aItem) then
      begin
        MyCPService.ACLDelete(aItem);
        acRefresh.Execute;
      end;
  *)
end;

procedure TfrmAccessControlList.acUpdateExecute(Sender: TObject);
(*
var
  aItem: ICPAccessControlListItem;
*)
begin
  (*
  if lbxUsers.ItemIndex > -1 then
    if lbxUsers.Items.Objects[lbxUsers.ItemIndex].GetInterface(ICPAccessControlListItem, aItem) then
      begin
        if rbtnReadOnly.Checked then
          MyCPService.ACLUpdate(aItem, alReadOnly);
        if rbtnReadWrite.Checked then
          MyCPService.ACLUpdate(aItem, alReadWrite);
        if rbtnReadWriteDelete.Checked then
          MyCPService.ACLUpdate(aItem, alReadWriteDelete);
        if rbtnFullControl.Checked then
          MyCPService.ACLUpdate(aItem, alFullControl);
      end;

  if aItem.getUserID = MyUser.getDUZ then {Did you update your own record here?}
    acRefresh.Execute;

  acUpdate.Enabled := False;
 *)
end;

procedure TfrmAccessControlList.lbxUsersClick(Sender: TObject);
//var
//  aItem: ICPAccessControlListItem;
begin
//  if lbxUsers.ItemIndex > -1 then
//    begin
//      lbxUsers.Items.Objects[lbxUsers.ItemIndex].GetInterface(ICPAccessControlListItem, aItem);
//      lblPermissions.Caption := Format('Permissions for %s:', [lbxUsers.Items[lbxUsers.ItemIndex]]);
//      rbtnReadOnly.Enabled := (MyCPService.ACLAccessLevel(fItem, MyUser as IPerson) = alFullControl);
//      rbtnReadWrite.Enabled := rbtnReadOnly.Enabled;
//      rbtnReadWriteDelete.Enabled := rbtnReadOnly.Enabled;
//      rbtnFullControl.Enabled := rbtnReadOnly.Enabled;
//      rbtnReadOnly.Checked := (aItem.getAccessLevel = alReadOnly);
//      rbtnReadWrite.Checked := (aItem.getAccessLevel = alReadWrite);
//      rbtnReadWriteDelete.Checked := (aItem.getAccessLevel = alReadWriteDelete);
//      rbtnFullControl.Checked := (aItem.getAccessLevel = alFullControl);
//    end
//  else
//    begin
//      rbtnReadOnly.Checked := False;
//      rbtnReadWrite.Checked := False;
//      rbtnReadWriteDelete.Checked := False;
//      rbtnFullControl.Checked := False;
//      rbtnReadOnly.Enabled := False;
//      rbtnReadWrite.Enabled := False;
//      rbtnReadWriteDelete.Enabled := False;
//      rbtnFullControl.Enabled := False;
//      lblPermissions.Caption := 'Permissions:';
//    end;
//  acUpdate.Enabled := False;
end;

procedure TfrmAccessControlList.PermissionChange(Sender: TObject);
begin
  acUpdate.Enabled := True;
end;

end.

