unit fAddADTTarget;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, oInterfaces, ComCtrls, StdCtrls, ExtCtrls, VA508AccessibilityManager;

type
  TfrmAddADTTarget = class(TForm)
    lvProtocols: TListView;
    lblProtocols: TLabel;
    Label1: TLabel;
    lblProtocolLinkName: TLabel;
    edtADTTargetName: TEdit;
    Label2: TLabel;
    cbMessageType: TComboBox;
    cbEventType: TComboBox;
    Label3: TLabel;
    btnOK: TButton;
    btnCancel: TButton;
    tvDivisions: TTreeView;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure lvProtocolsSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure edtADTTargetNameChange(Sender: TObject);
  private
    { Private declarations }
    FProtocols: ICPProtocolList;
    FDivisions: ICPDivisionList;
    procedure Validate;
  public
    { Public declarations }
    procedure Initialize(AProtocols: ICPProtocolList; ADivisions: ICPDivisionList);
    destructor Destroy; override;
  end;

var
  frmAddADTTarget: TfrmAddADTTarget;

implementation

{$R *.dfm}

{ TfrmAddADTTarget }

destructor TfrmAddADTTarget.Destroy;
begin
  FDivisions := nil;
  FProtocols := nil;
  inherited;
end;

procedure TfrmAddADTTarget.edtADTTargetNameChange(Sender: TObject);
begin
  Validate;
end;

procedure TfrmAddADTTarget.Initialize(AProtocols: ICPProtocolList;
  ADivisions: ICPDivisionList);
var
  Protocol: ICPProtocol;
  Division: ICPDivision;
  Ward: ICPWard;
  I, J: Integer;
  Item: TListItem;
  TVItem: TTreeNode;
  WardItem: TTreeNode;
begin
  FProtocols := AProtocols;
  FDivisions := ADivisions;

  for I := 0 to FProtocols.Count - 1 do
  begin
    Protocol := FProtocols[I] as ICPProtocol;
    Item := lvProtocols.Items.Add;

    Item.Caption := Protocol.getName;
    Item.Data := Pointer(Protocol);
  end;

  for I := 0 to FDivisions.Count - 1 do
  begin
    Division := FDivisions[I] as ICPDivision;
    TVItem := tvDivisions.Items.AddChild(nil,Division.getName);

    TVItem.Data := Pointer(Division);

    for J := 0 to Division.getWardList.Count - 1 do
    begin
      Ward := Division.getWardList[J] as ICPWard;
      WardItem := tvDivisions.Items.AddChild(TVItem, Ward.getWard);
      WardItem.Data := Pointer(Ward);
    end;
  end;
end;

procedure TfrmAddADTTarget.lvProtocolsSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  Validate;
end;

procedure TfrmAddADTTarget.Validate;
begin
  btnOK.Enabled :=
    (lvProtocols.Selected <> nil) and
    (tvDivisions.Selected <> nil) and
    (edtADTTargetName.Text <> '') and
    (cbMessageType.ItemIndex > -1) and
    (cbEventType.ItemIndex > -1);
end;

end.
