unit fEditFlowsheetPage;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  oInterfaces, VA508AccessibilityManager;

type
  TfrmEditFlowsheetPage = class(TForm)
    lblView: TLabel;
    Label2: TLabel;
    btnOk: TButton;
    btnCancel: TButton;
    memDisplayName: TMemo;
    cbxPageType: TComboBox;
    Label1: TLabel;
    Label3: TLabel;
    memSpecialInstructions: TMemo;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    VA508ComponentAccessibility1: TVA508ComponentAccessibility;
    cbxView: TComboBox;
    procedure ChangeMade(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure VA508ComponentAccessibility1CaptionQuery(Sender: TObject;
      var Text: string);
    procedure cbxViewEnter(Sender: TObject);
  private
    fPage: ICPFlowsheetPage;
  end;

function NewEditFlowsheetPageForm(aPage: ICPFlowsheetPage): TfrmEditFlowsheetPage;

implementation

uses
  oCPTypes,
  u508Dialogs,
  VA508AccessibilityRouter;

{$R *.dfm}

function NewEditFlowsheetPageForm(aPage: ICPFlowsheetPage): TfrmEditFlowsheetPage;
begin
  Result := TfrmEditFlowsheetPage.Create(Application);
  Result.fPage := aPage;
end;

{ TfrmEditFlowsheetPage }

procedure TfrmEditFlowsheetPage.btnOkClick(Sender: TObject);
var
  aView: ICPFlowsheetView;
begin
  try
    fPage.setDisplayName(memDisplayName.Text);
    fPage.setSpecialInstructions(memSpecialInstructions.Text);
    fPage.setPageType(TCPFlowsheetPageType(cbxPageType.ItemIndex));
    if cbxView.Items.Objects[cbxView.ItemIndex].GetInterface(ICPFlowsheetView, aView) then
      fPage.setFlowsheetView(aView);
    ModalResult := mrOk;
  except
    MessageDlg508('Error, flowsheet page defintion is incomplete.', mtError, [mbOk], 0);
  end;
end;

procedure TfrmEditFlowsheetPage.cbxViewEnter(Sender: TObject);
begin
  GetScreenReader.Speak('View: ');
end;

procedure TfrmEditFlowsheetPage.ChangeMade(Sender: TObject);
var
  aView: ICPFlowsheetView;
begin
  if Sender = cbxView then
    if cbxView.Items.Objects[cbxView.ItemIndex].GetInterface(ICPFlowsheetView, aView) then
      memDisplayName.Text := aView.getDisplayName;

  btnOk.Enabled :=
    (cbxView.ItemIndex > -1) and
    (cbxPageType.ItemIndex > -1) and
    (memDisplayName.Text <> '');
end;

procedure TfrmEditFlowsheetPage.VA508ComponentAccessibility1CaptionQuery(
  Sender: TObject; var Text: string);
begin
  Text := 'View';
end;

end.

