unit fEditFlowsheetTotal;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  oInterfaces,
  oCPTypes,
  oCliOTypes,
  ExtCtrls,
  StdCtrls,
  Buttons;

type
  TfrmEditFlowsheetTotal = class(TForm)
    btnCancel: TButton;
    btnOK: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private
    fFlowsheetTotal: ICPFlowsheetTotal;
  public
    function getFlowsheetTotal: ICPFlowsheetTotal;
    procedure setFlowsheetTotal(aValue: ICPFlowsheetTotal);
  end;

implementation

{$R *.dfm}

{ TfrmEditFlowsheetTotal }

procedure TfrmEditFlowsheetTotal.btnOKClick(Sender: TObject);
var
  i: integer;
  aTerm: ITerm;
begin
  {If fFlowsheetTotal is nil create one first}
  if not Assigned(fFlowsheetTotal) then
    Exit;

  with fFlowsheetTotal do
    begin
      setDisplayName(edtDisplayName.Text);
      setDefaultUnit(nil);
      if cbxDefaultUnit.ItemIndex > -1 then
        if cbxDefaultUnit.Items.Objects[cbxDefaultUnit.ItemIndex].GetInterface(ITerm, aTerm) then
          setDefaultUnit(aTerm);
      setDisplayTotal(chkbxTotal.Checked);
      setDisplayCount(chkbxCount.Checked);
      setDisplayAverage(chkbxAverage.Checked);
      setDisplayRatio(chkbxRatio.Checked);
      setDisplayDifference(chkbxDifference.Checked);
      ClearAllTerms;
      for i := 0 to lbxTermSelected.Count - 1 do
        if lbxTermSelected.Items.Objects[i].GetInterface(ITerm, aTerm) then
          AddTerm(aTerm);
    end;
end;

procedure TfrmEditFlowsheetTotal.FormCreate(Sender: TObject);
begin
  Font := Screen.IconFont;
  lblGeneral.Font.Style := [fsBold];
end;

function TfrmEditFlowsheetTotal.getFlowsheetTotal: ICPFlowsheetTotal;
begin
  Result := fFlowsheetTotal;
end;

procedure TfrmEditFlowsheetTotal.setFlowsheetTotal(aValue: ICPFlowsheetTotal);
var
  i: integer;
begin
  fFlowsheetTotal := aValue;
  edtDisplayName.Text := fFlowsheetTotal.getDisplayName;

  if Assigned(fFlowsheetTotal.getDefaultUnit) then
    cbxDefaultUnit.ItemIndex := fFlowsheetTotal.getDefaultUnit.getIndex(cbxDefaultUnit.Items);

  lbxTermSelected.Items.Clear;
  for i := 0 to fFlowsheetTotal.getTermCount - 1 do
    fFlowsheetTotal.getTerm(i).AddToList(lbxTermSelected.Items, tdTerm);
end;

end.

