unit fTester;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 5 $  $Modtime: 5/20/09 3:29p $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Developers unit.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/CP Console/fTester.pas $
*
* $History: fTester.pas $
 * 
 * *****************  Version 5  *****************
 * User: Zzzzzzjuergb Date: 5/22/09    Time: 2:17p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Build Pre-275:  
 * 
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 12/06/07   Time: 4:48p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 4/25/07    Time: 8:08a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Begin Alpha Testing
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 4/10/07    Time: 3:31p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Revamp of terminology to all interfaces.
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:38p
 * Created in $/CP Modernization/CliO/source/CP Console
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  oCliOTypes,
  oInterfaces;

type
  TfrmTester = class(TForm)
    ListView1: TListView;
    edtVendorkey: TEdit;
    Label1: TLabel;
    cbxType: TComboBox;
    Label2: TLabel;
    Button1: TButton;
    edtSourceID: TEdit;
    Label3: TLabel;
    edtSourceApplication: TEdit;
    Label4: TLabel;
    edtSourceVersion: TEdit;
    Label5: TLabel;
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure Button1Click(Sender: TObject);
  private
    fMapper: ITermMapper;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmTester: TfrmTester;

implementation

uses fMain,
  u508Dialogs;

{$R *.dfm}

procedure TfrmTester.ListView1SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  if Selected then
    with Item do
      begin
        edtSourceID.Text := SubItems[0];
        edtSourceApplication.Text := SubItems[1];
        edtSourceVersion.Text := SubItems[2];
        edtVendorkey.Text := '';
        cbxType.ItemIndex := -1;
        fMapper := MyTerminology.GetTermMapper(
          edtSourceID.Text, edtSourceApplication.Text, edtSourceVersion.Text);
        Button1.Enabled := fMapper <> nil;
      end;
end;

procedure TfrmTester.Button1Click(Sender: TObject);
var
  aID: string;
begin
  try
    aID := fMapper.getTerm(TTermType(cbxType.ItemIndex), edtVendorkey.Text);
    with MyTerminology.GetTerm(aID) do
      ShowMessageFmt('Term ID: %s - Name: %s', [getID, getTerm]);
  except
    on E: Exception do
      MessageDlg508(E.Message, mtError, [mbOk], 0);
  end;
end;

end.
