unit fXMLExport;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 17 $  $Modtime: 12/08/11 9:02a $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Export Wizard for CPConsole.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Flowsheets/CliO/source/CP Console/fXMLExport.pas $
*
* $History: fXMLExport.pas $
 * 
 * *****************  Version 17  *****************
 * User: Zzzzzzjuergb Date: 12/09/11   Time: 9:12a
 * Updated in $/CP Flowsheets/CliO/source/CP Console
 * Fixed Magic 4 and minor changes to CP Console.
 * 
 * *****************  Version 16  *****************
 * User: Zzzzzzjuergb Date: 10/07/11   Time: 3:01p
 * Updated in $/CP Flowsheets/CliO/source/CP Console
 * 
 * *****************  Version 15  *****************
 * User: Zzzzzzjuergb Date: 12/02/09   Time: 2:15p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 
 * *****************  Version 14  *****************
 * User: Zzzzzzpetitd Date: 8/18/09    Time: 9:21a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Cleanup of the Wizards and added complete field listing for view
 * definitions.
 * 
 * *****************  Version 13  *****************
 * User: Zzzzzzjuergb Date: 5/28/09    Time: 10:49a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Build 275
 * 
 * *****************  Version 12  *****************
 * User: Zzzzzzjuergb Date: 5/22/09    Time: 2:17p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Build Pre-275:  
 * 
 * *****************  Version 11  *****************
 * User: Zzzzzzpetitd Date: 4/08/08    Time: 8:17p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 10  *****************
 * User: Zzzzzzpetitd Date: 4/06/08    Time: 3:11p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 9  *****************
 * User: Zzzzzzpetitd Date: 4/03/08    Time: 5:13p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 8  *****************
 * User: Zzzzzzpetitd Date: 3/08/08    Time: 9:51p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 7  *****************
 * User: Zzzzzzpetitd Date: 2/16/08    Time: 4:02p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 6  *****************
 * User: Zzzzzzpetitd Date: 9/05/07    Time: 3:25p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 5  *****************
 * User: Zzzzzzpetitd Date: 7/25/07    Time: 12:33p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Working on the recursive load call so that we can respond back on the
 * progress of the observation loader.
 *
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 7/06/07    Time: 10:17a
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 6/28/07    Time: 8:58p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 4/25/07    Time: 8:09a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Begin Alpha Testing
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/24/06   Time: 8:47a
 * Created in $/CP Modernization/CliO/source/CP Console
 * Initial Check-In
 *
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ActnList,
  StdCtrls,
  CheckLst,
  ExtCtrls,
  ComCtrls,
  oCliOTypes,
  oInterfaces,
  XMLDoc,
  XMLIntf, VA508AccessibilityManager;

type
  TfrmXMLExport = class(TForm)
    pnlControls: TPanel;
    Bevel1: TBevel;
    btnCancel: TButton;
    btnNext: TButton;
    btnBack: TButton;
    ActionList1: TActionList;
    acCancel: TAction;
    acNext: TAction;
    acBack: TAction;
    acLoadItems: TAction;
    acSelectType: TAction;
    acSelectItems: TAction;
    acBuildXML: TAction;
    pnlLeft: TPanel;
    acFinish: TAction;
    Shape1: TShape;
    acBrowse: TAction;
    Image1: TImage;
    Bevel8: TBevel;
    dlgGetFilename: TSaveDialog;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    nbkWizard: TNotebook;
    pnlIntro: TPanel;
    Bevel2: TBevel;
    Bevel4: TBevel;
    lblContinue: TLabel;
    lblWelcome: TStaticText;
    lblInstructions: TStaticText;
    Bevel9: TBevel;
    Label9: TLabel;
    cbType: TComboBox;
    StaticText1: TStaticText;
    Panel1: TPanel;
    lblSelectInstructions: TLabel;
    Bevel10: TBevel;
    clbxItems: TCheckListBox;
    Label10: TLabel;
    Bevel12: TBevel;
    Bevel13: TBevel;
    lblExportFilename: TLabel;
    edtFilename: TEdit;
    lblComments: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    memXMLText: TMemo;
    Label13: TLabel;
    lblFinished: TStaticText;
    StaticText3: TStaticText;
    btnBrowse: TButton;
    memComments: TMemo;
    procedure acNextExecute(Sender: TObject);
    procedure acLoadItemsExecute(Sender: TObject);
    procedure acSelectTypeExecute(Sender: TObject);
    procedure acSelectItemsExecute(Sender: TObject);
    procedure acBuildXMLExecute(Sender: TObject);
    procedure acBackExecute(Sender: TObject);
    procedure acFinishExecute(Sender: TObject);
    procedure acBrowseExecute(Sender: TObject);
    procedure acCancelExecute(Sender: TObject);
    procedure clbxItemsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure edtFilenameChange(Sender: TObject);
  private
    function LoadItem(aItem: ICPConsoleItem; aNode: IXMLNode): boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmXMLExport: TfrmXMLExport;

function ExecuteXMLExport: boolean;

implementation

uses
  oCPTypes,
  uCPXML,
  fMain,
  VA508AccessibilityRouter,
  u508Dialogs;

{$R *.dfm}

function ExecuteXMLExport: boolean;
var
  AccessList: ICPParameterFile;
begin
  with TfrmXMLExport.Create(Application) do
    try
      {
      blj 4 October 2011: We need to check to see which items we have
        permission to export first.  Then we need to get the combobox set
        up correctly.
        ciProcedure, ciInstrument, ciFlowsheetView
      }

      AccessList := MyCPService.getAccessParameters;
      if AccessList.ReadBoolean(pkUser, CONSOLE_ITEM_HEADER[ciFlowsheetView], false) or
         myUser.HasRole('MD ADMINISTRATOR') then
        cbType.Items.Add(CONSOLE_ITEM_HEADER[ciFlowsheetView]);

      if AccessList.ReadBoolean(pkUser, CONSOLE_ITEM_HEADER[ciInstrument], false) or
        myUser.HasRole('MD ADMINISTRATOR') then
        cbType.Items.Add(CONSOLE_ITEM_HEADER[ciInstrument]);

      if AccessList.ReadBoolean(pkUser, CONSOLE_ITEM_HEADER[ciProcedure], false) or
        myUser.HasRole('MD ADMINISTRATOR') then
        cbType.Items.Add(CONSOLE_ITEM_HEADER[ciProcedure]);

      Font := Screen.IconFont;
      lblWelcome.Font.Size := 12;
      lblWelcome.Font.Style := [fsBold];
      lblFinished.Font.Size := 12;
      lblFinished.Font.Style := [fsBold];
      {
      tbshtIntro.TabVisible := False;
      tbshtType.TabVisible := False;
      tbshtWhich.TabVisible := False;
      tbshtViewXML.TabVisible := False;
      tbshtFinished.TabVisible := False;
      tbshtGetFilename.TabVisible := False;
      }
      nbkWizard.ActivePage := 'tbshtIntro';
      Result := (ShowModal = mrOK);
    finally
      Free;
    end;
end;

procedure TfrmXMLExport.acNextExecute(Sender: TObject);
begin
  case nbkWizard.PageIndex of
    0: {Intro}
      begin
        //pgctrl.ActivePage := tbshtType;
        nbkWizard.ActivePage := 'tbshtType';
        cbType.SetFocus;
        acNext.Enabled := False;
        acBack.Enabled := True;
      end;
    1: {Type is selected}
      begin
        acLoadItems.Execute;
        //pgctrl.ActivePage := tbshtWhich;
        nbkWizard.ActivePage := 'tbshtWhich';
        clbxItems.SetFocus;
        acNext.Enabled := False;
      end;
    2: {Items are selected}
      begin
        //pgctrl.ActivePage := tbshtGetFilename;
        nbkWizard.ActivePage := 'tbshtGetFilename';
        edtFilename.SetFocus;
        acNext.Enabled := (edtFilename.Text <> '');
      end;
    3: {We have a filename}
      begin
        acBuildXML.Execute;
        //pgctrl.ActivePage := tbshtViewXML;
        nbkWizard.ActivePage := 'tbshtViewXML';
        memXMLText.SetFocus;
        acNext.Enabled := True;
      end;
    4:
      begin
        memXMLText.Lines.SaveToFile(edtFileName.Text);
        //pgctrl.ActivePage := tbshtFinished;
        nbkWizard.ActivePage := 'tbshtFinished';
        lblFinished.SetFocus;
        acBack.Enabled := False;
        acNext.Enabled := False;
        btnCancel.Enabled := False;
        btnNext.Action := acFinish;
      end;
  end;
end;

procedure TfrmXMLExport.acBackExecute(Sender: TObject);
begin
  // If we've hit a back, Next should always be enabled.
  acNext.Enabled := true;

  case nbkWizard.PageIndex of
    0: {Intro}
      begin
        acBack.Enabled := False;
      end;
    1: {Type is selected}
      begin
        //pgctrl.ActivePage := tbshtIntro;
        nbkWizard.ActivePage := 'tbshtIntro';
        acBack.Enabled := False;
      end;
    2: {Items are selected}
      begin
        //pgctrl.ActivePage := tbshtType;
        nbkWizard.ActivePage := 'tbshtType';
        acBack.Enabled := True;
      end;
    3: {Save it and move on}
      begin
        //pgctrl.ActivePage := tbshtWhich;
        nbkWizard.ActivePage := 'tbshtWhich';
        acBack.Enabled := True;
      end;
    4:
      begin
        nbkWizard.ActivePage := 'tbshtGetFilename';
        acBack.Enabled := true;
      end;
    5:
      begin
        nbkWizard.ActivePage := 'tbshtViewXML';
        acBack.Enabled := true;
      end;
  end;
end;

procedure TfrmXMLExport.acLoadItemsExecute(Sender: TObject);
begin
  clbxItems.Clear;

  if cbType.Items[cbType.ItemIndex] = CONSOLE_ITEM_HEADER[ciFlowsheetView] then
     MyCPService.LoadList(clbxItems.Items, ciFlowsheetView, False);

  if cbType.Items[cbType.ItemIndex] = CONSOLE_ITEM_HEADER[ciProcedure] then
     MyCPService.LoadList(clbxItems.Items, ciProcedure, False);

  if cbType.Items[cbType.ItemIndex] = CONSOLE_ITEM_HEADER[ciInstrument] then
     MyCPService.LoadList(clbxItems.Items, ciInstrument, False);

  acNext.Enabled := (clbxItems.Items.Count > 0);
  lblSelectInstructions.Caption := Format('The following %d items are available for export.' + #13 + 'Press Ctrl-A to select all items.', [clbxItems.Count]);
end;

procedure TfrmXMLExport.acSelectTypeExecute(Sender: TObject);
begin
  acNext.Enabled := (cbType.ItemIndex > -1);
end;

procedure TfrmXMLExport.acSelectItemsExecute(Sender: TObject);
var
  i: integer;
  j: integer;
begin
  j := 0;
  for i := 0 to clbxItems.Items.Count - 1 do
    if clbxItems.Checked[i] then
      inc(j);
  acNext.Enabled := (j > 0);
end;

procedure TfrmXMLExport.acBuildXMLExecute(Sender: TObject);
var
  aXMLDoc: IXMLDocument;
  aXMLNode: IXMLNode;
  i: integer;
  aItem: ICPConsoleItem;
begin
  try
    aXMLDoc := NewXMLDocument;
    aXMLDoc.DocumentElement := aXMLDoc.AddChild('CP_CONSOLE_COMPONENTS');
    aXMLDoc.DocumentElement.ChildValues['DATE_CREATED'] := DateTimeToXMLString(Now);
    aXMLDoc.DocumentElement.ChildValues['VERSION'] := 1.0;
    if memComments.Text <> '' then
      aXMLDoc.DocumentElement.ChildValues['COMMENTS'] := memComments.Text
    else
      aXMLDoc.DocumentElement.ChildValues['COMMENTS'] := 'No Comments Entered';
    aXMLNode := aXMLDoc.DocumentElement;
    for i := 0 to clbxItems.Items.Count - 1 do
      if clbxItems.Checked[i] then
        begin
          if clbxItems.Items.Objects[i].GetInterface(ICPConsoleItem, aItem) then
            LoadItem(aItem, aXMLNode);
        end;
    memXMLText.Lines.Text := FormatXMLData(aXMLDoc.XML.Text);
    nbkWizard.ActivePage := 'tbshtViewXML';
    acNext.Enabled := (edtFileName.Text <> '');
  except
    on e: Exception do
      MessageDlg508('Error creating XML Document' + #13 + e.Message, mtError,
        [mbOk], 0);
  end;
end;

procedure TfrmXMLExport.acFinishExecute(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TfrmXMLExport.acBrowseExecute(Sender: TObject);
begin
  if dlgGetFileName.Execute then
    begin
      edtFileName.Text := dlgGetFileName.FileName;
      acNext.Enabled := True;
    end
  else
    acNext.Enabled := (edtFileName.Text <> '');
end;

procedure TfrmXMLExport.acCancelExecute(Sender: TObject);
begin
  if MessageDlg508('Are you sure you want to cancel this Wizard?', mtConfirmation,
    mbYesNo, 0) = mrYes then
    ModalResult := mrCancel;
end;

function TfrmXMLExport.LoadItem(aItem: ICPConsoleItem; aNode: IXMLNode): boolean;
var
  aXMLDoc: IXMLDocument;
  aSourceNode: IXMLNode;
  aTargetNode: IXMLNode;
begin
  aXMLDoc := NewXMLDocument;
  try
    case aItem.getItemType of
      ciProcedure:
        begin
          MyDBConnection.ExecQuery('ExportProcedure', [aItem.getID], aXMLDoc);
          aSourceNode := XMLDocumentFirstRecord(aXMLDoc);
          if Assigned(aSourceNode) then
            begin
              aSourceNode.Attributes['TYPE'] := aItem.getItemType;
              aSourceNode.Attributes['ID'] := aItem.getID;
              aSourceNode.Attributes['DISPLAY_NAME'] := aItem.getDisplayName;
              aTargetNode := aSourceNode.CloneNode(True);
              aNode.ChildNodes.Add(aTargetNode);
            end;
        end;
      ciInstrument:
        begin
          MyDBConnection.ExecQuery('ExportInstrument', [aItem.getID], aXMLDoc);
          aSourceNode := XMLDocumentFirstRecord(aXMLDoc);
          if Assigned(aSourceNode) then
            begin
              aSourceNode.Attributes['TYPE'] := aItem.getItemType;
              aSourceNode.Attributes['ID'] := aItem.getID;
              aSourceNode.Attributes['DISPLAY_NAME'] := aItem.getDisplayName;
              aTargetNode := aSourceNode.CloneNode(True);
              aNode.ChildNodes.Add(aTargetNode);
            end;
        end;
      ciFlowsheetView:
        begin
          MyDBConnection.ExecQuery('ExportView', [aItem.getID], aXMLDoc);
          aSourceNode := XMLDocumentFirstRecord(aXMLDoc);
          if Assigned(aSourceNode) then
            begin
              aSourceNode.Attributes['TYPE'] := aItem.getItemType;
              aSourceNode.Attributes['ID'] := aItem.getID;
              aSourceNode.Attributes['DISPLAY_NAME'] := aItem.getDisplayName;
              aTargetNode := aSourceNode.CloneNode(True);
              MyDBConnection.ExecQuery('ExportViewTerminology', [aItem.getID], aXMLDoc);
              with aTargetNode.AddChild('TERMINOLOGY') do
                begin
                  aSourceNode := XMLDocumentFirstRecord(aXMLDoc);
                  while Assigned(aSourceNode) do
                    begin
                      ChildNodes.Add(aSourceNode.CloneNode(True));
                      aSourceNode := XMLDocumentNextRecord(aSourceNode);
                    end;
                end;
              MyDBConnection.ExecQuery('ExportViewFilters', [aItem.getID], aXMLDoc);
              with aTargetNode.AddChild('FILTERS') do
                begin
                  aSourceNode := XMLDocumentFirstRecord(aXMLDoc);
                  while Assigned(aSourceNode) do
                    begin
                      ChildNodes.Add(aSourceNode.CloneNode(True));
                      aSourceNode := XMLDocumentNextRecord(aSourceNode);
                    end;
                end;
              aNode.ChildNodes.Add(aTargetNode);
            end;
        end;
      ciMappingTable:
        begin
          MyDBConnection.ExecQuery('ExportMappingTable', [aItem.getID], aXMLDoc);
          aSourceNode := XMLDocumentFirstRecord(aXMLDoc);
          if Assigned(aSourceNode) then
            begin
              aSourceNode.Attributes['TYPE'] := aItem.getItemType;
              aSourceNode.Attributes['ID'] := aItem.getID;
              aSourceNode.Attributes['DISPLAY_NAME'] := aItem.getDisplayName;
              aTargetNode := aSourceNode.CloneNode(True);
              MyDBConnection.ExecQuery('ExportMappingTableTerms', [aItem.getID], aXMLDoc);
              with aTargetNode.AddChild('TERMS') do
                begin
                  aSourceNode := XMLDocumentFirstRecord(aXMLDoc);
                  while Assigned(aSourceNode) do
                    begin
                      ChildNodes.Add(aSourceNode.CloneNode(True));
                      aSourceNode := XMLDocumentNextRecord(aSourceNode);
                    end;
                end;
              aNode.ChildNodes.Add(aTargetNode);
            end;
        end;
    end;
  except
    on e: Exception do
    begin
      MessageDlg508('Error Loading' + e.Message, mtError, [mbOk], 0);
    end;
  end;
  result := true;
end;

procedure TfrmXMLExport.clbxItemsKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  i: integer;
begin
  if (Key = 65) and (ssCtrl in Shift) then
    if MessageDlg508('Select all items in the list?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      for i := 0 to clbxItems.Items.Count - 1 do
        clbxItems.Checked[i] := True;
  acNext.Enabled := (clbxItems.Items.Count > 0);
end;

procedure TfrmXMLExport.edtFilenameChange(Sender: TObject);
begin
  acNext.Enabled := edtFilename.Text <> '';
end;

procedure TfrmXMLExport.FormShow(Sender: TObject);
begin
  VA508AccessibilityManager1.RefreshComponents;
  nbkWizard.SetFocus;
end;

end.

