unit fXMLImport;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 16 $  $Modtime: 12/08/11 11:41a $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Import Wizard for CPConsole.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Flowsheets/CliO/source/CP Console/fXMLImport.pas $
*
* $History: fXMLImport.pas $
 * 
 * *****************  Version 16  *****************
 * User: Zzzzzzjuergb Date: 12/09/11   Time: 9:13a
 * Updated in $/CP Flowsheets/CliO/source/CP Console
 * Fixed Magic 4 and minor changes to CP Console.
 * 
 * *****************  Version 15  *****************
 * User: Zzzzzzjuergb Date: 10/07/11   Time: 3:01p
 * Updated in $/CP Flowsheets/CliO/source/CP Console
 * 
 * *****************  Version 14  *****************
 * User: Zzzzzzjuergb Date: 12/02/09   Time: 2:15p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 
 * *****************  Version 13  *****************
 * User: Zzzzzzpetitd Date: 8/18/09    Time: 9:22a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Cleanup of the Wizards and added complete field listing for view
 * definitions.
 *
 * *****************  Version 12  *****************
 * User: Zzzzzzjuergb Date: 5/28/09    Time: 10:49a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Build 275
 *
 * *****************  Version 11  *****************
 * User: Zzzzzzjuergb Date: 5/22/09    Time: 2:17p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Build Pre-275:
 *
 * *****************  Version 10  *****************
 * User: Zzzzzzpetitd Date: 4/18/08    Time: 8:50a
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 9  *****************
 * User: Zzzzzzpetitd Date: 4/06/08    Time: 3:11p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 8  *****************
 * User: Zzzzzzpetitd Date: 3/13/08    Time: 8:59p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 7  *****************
 * User: Zzzzzzpetitd Date: 12/14/07   Time: 10:43a
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 6  *****************
 * User: Zzzzzzpetitd Date: 9/05/07    Time: 3:26p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 5  *****************
 * User: Zzzzzzpetitd Date: 7/06/07    Time: 10:17a
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 6/28/07    Time: 8:59p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 5/01/07    Time: 11:52a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Training session May 1, 2007
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 4/25/07    Time: 8:09a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Begin Alpha Testing
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/24/06   Time: 8:48a
 * Created in $/CP Modernization/CliO/source/CP Console
 * Initial Check-In
 *
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  CheckLst,
  ExtCtrls,
  ComCtrls,
  ActnList,
  XMLIntf,
  XMLDoc,
  oCPTypes,
  oCliOTypes,
  oInterfaces,
  VA508AccessibilityManager, System.Actions;

type
  TfrmXMLImport = class(TForm)
    pnlControls: TPanel;
    Bevel1: TBevel;
    btnCancel: TButton;
    btnNext: TButton;
    btnBack: TButton;
    pnlLeft: TPanel;
    Shape1: TShape;
    Image1: TImage;
    Bevel8: TBevel;
    ActionList1: TActionList;
    acNext: TAction;
    acBack: TAction;
    acCancel: TAction;
    acLoadItems: TAction;
    acBrowse: TAction;
    dlgGetFileName: TOpenDialog;
    acSelectItems: TAction;
    acImportItems: TAction;
    acFinish: TAction;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    nbkWizard: TNotebook;
    pnlMainIntro: TPanel;
    pnlIntro: TPanel;
    Bevel4: TBevel;
    lblContinue: TLabel;
    Bevel2: TBevel;
    Bevel5: TBevel;
    pnlGetFilename: TPanel;
    Label1: TLabel;
    Bevel12: TBevel;
    pnlDescription: TPanel;
    Label5: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    memComments: TMemo;
    edtDateCreated: TEdit;
    edtVersion: TEdit;
    edtComponentsFound: TEdit;
    Label8: TStaticText;
    edtFileName: TEdit;
    Button1: TButton;
    Bevel13: TBevel;
    Label2: TLabel;
    pnlWhich: TPanel;
    lblSelectInstructions: TLabel;
    Bevel6: TBevel;
    clbxItems: TCheckListBox;
    Bevel3: TBevel;
    Label4: TLabel;
    pnlProgress: TPanel;
    Label7: TLabel;
    Bevel10: TBevel;
    memProgress: TMemo;
    pnlFinished: TPanel;
    stFinished: TStaticText;
    Bevel9: TBevel;
    Label6: TLabel;
    Bevel11: TBevel;
    memFinalMessages: TMemo;
    Label3: TLabel;
    Bevel7: TBevel;
    lblWelcome: TLabel;
    Label13: TLabel;
    procedure acNextExecute(Sender: TObject);
    procedure acBrowseExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acLoadItemsExecute(Sender: TObject);
    procedure acSelectItemsExecute(Sender: TObject);
    procedure acImportItemsExecute(Sender: TObject);
    procedure acFinishExecute(Sender: TObject);
    procedure acCancelExecute(Sender: TObject);
    procedure clbxItemsKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure acBackExecute(Sender: TObject);
  protected
    fImportDocument: IXMLDocument;
    fInterfaceList: TInterfaceList;
    fCommandName: string;
    fParams: array of variant;

    function DoesItemExist(aItemType: TCPItemType; aItemID: string): boolean;

    function ImportItem(aXMLNode: IXMLNode): boolean;
    function LoadInstrumentValues(aXMLNode: IXMLNode; aUpdateExisting: boolean): boolean;
    function LoadProcedureValues(aXMLNode: IXMLNode; aUpdateExisting: boolean): boolean;
    function LoadViewValues(aXMLNode: IXMLNode; aUpdateExisting: boolean): boolean;
    function LoadViewTerminologyValues(aXMLNode: IXMLNode): boolean;
    function LoadViewFilterValues(aXMLNode: IXMLNode): boolean;
    function LoadMappingTableValues(aXMLNode: IXMLNode; aUpdateExisting: boolean): boolean;
    function LoadMappingTableTermValues(aXMLNode: IXMLNode; aTableID: string): boolean;

    function ImportTerminology(aXMLNode: IXMLNode): boolean;

    function LoadTermValues(aXMLNode: IXMLNode; aUpdateExisting: boolean): boolean;
    function LoadTermPairValues(aXMLNode: IXMLNode): boolean;
    function LoadTermUnitConversionValues(aXMLNode: IXMLNode): boolean;
    function LoadTermUnitPairValues(aXMLNode: IXMLNode): boolean;
    function LoadTermChildValues(aXMLNode: IXMLNode): boolean;
    function LoadTermRangeCheckValues(aXMLNode: IXMLNode): boolean;
  public
    { Public declarations }
  end;

var
  frmXMLImport: TfrmXMLImport;

function ExecuteXMLImport: boolean;

implementation

uses
  uCPXML,
  fMain,
  VA508AccessibilityRouter,
  u508Dialogs;

const
  COMPONENT_NAME_ARRAY: array[0..7] of string = (
    'stWelcome',
    'StaticText1',
    'Label8',
    'memComments',
    'clbxItems',
    'memProgress',
    'stFinished',
    'memFinalMessages'
    );

{$R *.dfm}

function ExecuteXMLImport: boolean;
var
  I: Integer;
  TabStopVal: Boolean;

  function PresentInArray(const Name: string): boolean;
  var
    J: Integer;
  begin
    result := false;
    // DRM - I17133608FY18/613689 - 2017/10/27 - SizeOf(..) is returning 32,
    // which is, coincidentally enough, the size of an array of 8 pointers to strings.
    //for J := 0 to SizeOf(COMPONENT_NAME_ARRAY) - 1 do
    for J := Low(COMPONENT_NAME_ARRAY) to High(COMPONENT_NAME_ARRAY) do
    // DRM ---
      begin
        if COMPONENT_NAME_ARRAY[J] = Name then
          begin
            result := true;
            exit;
          end;
      end;
  end;
begin
  with TfrmXMLImport.Create(Application) do
    try
      TabStopVal := ScreenReaderSystemActive;
      for I := 0 to ControlCount - 1 do
        begin
          if PresentInArray(Controls[I].Name) then
            TWinControl(Controls[I]).TabStop := TabStopVal;
        end;

      Font := Screen.IconFont;
      lblWelcome.Font.Size := 12;
      lblWelcome.Font.Style := [fsBold];
      stFinished.Font.Size := 12;
      stFinished.Font.Style := [fsBold];
//      tbshtIntro.TabVisible := False;
//      tbshtWhich.TabVisible := False;
//      tbshtFinished.TabVisible := False;
//      tbshtGetFilename.TabVisible := False;
//      tbshtProgress.TabVisible := False;
      nbkWizard.ActivePage := 'tbshtIntro';
      Result := (ShowModal = mrOK);
    finally
      Free;
    end;
end;

procedure TfrmXMLImport.FormCreate(Sender: TObject);
begin
  fInterfaceList := TInterfaceList.Create;
  fImportDocument := NewXMLDocument;
end;

procedure TfrmXMLImport.FormShow(Sender: TObject);
begin
  pnlIntro.SetFocus;
end;

procedure TfrmXMLImport.acNextExecute(Sender: TObject);
begin
  case nbkWizard.PageIndex of
    0: {Intro}
      begin
        nbkWizard.ActivePage := 'tbshtGetFilename';
        edtFilename.SetFocus;
        acNext.Enabled := False;
        acBack.Enabled := True;
      end;
    1: {Filename is selected and was successfully loaded in acBrowse.Execute}
      begin
        nbkWizard.ActivePage := 'tbshtWhich';
        clbxItems.SetFocus;
        acNext.Enabled := False;
      end;
    2: {Items are selected, lets import them!!!}
      begin
        nbkWizard.ActivePage := 'tbshtProgress';
        memProgress.SetFocus;
        acImportItems.Execute;
      end;
  end;
end;

procedure TfrmXMLImport.acBackExecute(Sender: TObject);
begin
  case nbkWizard.PageIndex of
    1: {Intro}
      begin
        nbkWizard.ActivePage := 'tbshtIntro';
        pnlIntro.SetFocus;
        acNext.Enabled := True;
        acBack.Enabled := False;
      end;
    2: {Filename is selected and was successfully loaded in acBrowse.Execute}
      begin
        nbkWizard.ActivePage := 'tbshtGetFilename';
        edtFilename.SetFocus;
        acNext.Enabled := False;
        acBack.Enabled := True;
      end;
    3: {Items are selected, lets import them!!!}
      begin
        nbkWizard.ActivePage := 'tbshtWhich';
        clbxItems.SetFocus;
        acNext.Enabled := False;
      end;
    4: {Just to set focus so we can get messages if we're in a screen reader.}
      begin
        acImportItems.Execute;
      end;
  end;
end;

procedure TfrmXMLImport.acBrowseExecute(Sender: TObject);
begin
  if dlgGetFileName.Execute then
    begin
      edtFileName.Text := dlgGetFileName.Filename;
      acLoadItems.Execute;
    end;
end;

procedure TfrmXMLImport.acLoadItemsExecute(Sender: TObject);
var
  aNode: IXMLNode;
begin
  try
    fInterfaceList.Clear;
    clbxItems.Clear;
    memComments.Lines.Clear;
    fImportDocument.LoadFromFile(edtFileName.Text);
    fImportDocument.Active := True;
    if fImportDocument.DocumentElement.NodeName <> 'CP_CONSOLE_COMPONENTS' then
      raise Exception.Create('Not a valid CP Console Component file');
    if XMLValueAsDouble(fImportDocument.DocumentElement, 'VERSION') <> 1.0 then
      raise Exception.Create('Invalid version of a CP Console Component file');

    edtDateCreated.Text := XMLValueAsStr(fImportDocument.DocumentElement, 'DATE_CREATED');
    edtVersion.Text := Format('%0.1f', [XMLValueAsDouble(fImportDocument.DocumentElement, 'VERSION')]);
    memComments.Text := XMLValueAsStr(fImportDocument.DocumentElement, 'COMMENTS');

    aNode := XMLDocumentFirstRecord(fImportDocument);
    while Assigned(aNode) do
      begin
        {
        IMPORTANT****
        The clbxItems.ItemIndex points to the fInterfaceList index of the node
        }
        fInterfaceList.Add(aNode);
        clbxItems.Items.Add(aNode.Attributes['DISPLAY_NAME']);
        aNode := XMLDocumentNextRecord(aNode);
      end;
    case fInterfaceList.Count of
      0: MessageDlg508('No CP components found in this file for import', mtInformation, [mbOk], 0);
      1: lblSelectInstructions.Caption := 'The following component was found.';
    else
      lblSelectInstructions.Caption :=
        Format('The following %d CP components were found.', [fInterfaceList.Count]);
    end;
    lblSelectInstructions.Caption := lblSelectInstructions.Caption + #13 + 'Press Ctrl-A to select all items.';
    edtComponentsFound.Text := IntToStr(fInterfaceList.Count);
    pnlDescription.Visible := fInterfaceList.Count > 0;
    acNext.Enabled := fInterfaceList.Count > 0;
  except
    on E: Exception do
      MessageDlg508('Error Loading File:' + #13 +
        'Error Message: ' + E.Message, mtError, [mbOK], 0);
  end;
end;

procedure TfrmXMLImport.acSelectItemsExecute(Sender: TObject);
var
  i: integer;
  j: integer;
begin
  j := 0;
  for i := 0 to clbxItems.Items.Count - 1 do
    if clbxItems.Checked[i] then
      inc(j);
  acNext.Enabled := (j > 0);
end;

procedure TfrmXMLImport.acImportItemsExecute(Sender: TObject);
var
  i: integer;
  aNode: IXMLNode;
begin
  try
    nbkWizard.ActivePage := 'tbshtProgress';
    memProgress.Lines.Clear;
    memFinalMessages.Lines.Clear;
    for i := 0 to clbxItems.Items.Count - 1 do
      if clbxItems.Checked[i] then
        if fInterfaceList[i].QueryInterface(IXMLNode, aNode) = 0 then
          try
            if ImportItem(aNode) then
              memFinalMessages.Lines.Add(clbxItems.Items[i] + ' imported. ')
            else
              memFinalMessages.Lines.Add(clbxItems.Items[i] + ' skipped. ');
          except
            on E: Exception do
              begin
                memFinalMessages.Lines.Add('Error importing ' + clbxItems.Items[i]);
                memFinalMessages.Lines.Add('  -> ' + E.Message);
              end;
          end
  finally
    btnNext.Action := acFinish;
    nbkWizard.ActivePage := 'tbshtFinished';
    //memFinalMessages.SetFocus;
  end;
end;

function TfrmXMLImport.ImportItem(aXMLNode: IXMLNode): boolean;
var
  aType: TCPItemType;
  aID: string;
  aUpdate: Boolean;
  aSubNode: IXMLNode;
  AccessList: ICPParameterFile;
begin
  aID := aXMLNode.Attributes['ID'];
  if aXMLNode.Attributes['TYPE'] = 100 then
    if MyUser.HasRole('MD MANAGER') then
      begin
        ImportTerminology(aXMLNode);
        Result := True;
        Exit;
      end
    else
      begin
        MessageDlg508('You do not have the appropriate authorization to install this file.', mtError, [mbOk], 0);
        Result := False;
        Exit;
      end;

  AccessList := MyCPService.getAccessParameters;


  aType := TCPItemType(StrToInt(VarToStrDef(aXMLNode.Attributes['TYPE'], '-1')));

  {Does it exist????}
  aUpdate := DoesItemExist(aType, aID);
  if aUpdate then
    if MessageDlg508('An item with ID: ' + aID + ' already exists in this account.' + #13 +
      'Name: ' + aXMLNode.Attributes['DISPLAY_NAME'] + #13 + #13 +
      'Note: Item may be under another name but the ID does exist and will be overwritten.' + #13 + #13 +
      'Do you want to overwrite this item?', mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
      begin
        memProgress.Lines.Add('Skipped ' + CONSOLE_ITEM_HEADER[aType] + ': ' + aXMLNode.Attributes['DISPLAY_NAME']);
        Result := False;
        Exit;
      end;

  if aUpdate then
    memProgress.Lines.Add('Update ' + CONSOLE_ITEM_HEADER[aType] + ': ' + aXMLNode.Attributes['DISPLAY_NAME'])
  else
    memProgress.Lines.Add('Import ' + CONSOLE_ITEM_HEADER[aType] + ': ' + aXMLNode.Attributes['DISPLAY_NAME']);

  Application.ProcessMessages;

  case aType of
    ciProcedure:
      begin
        if AccessList.ReadBoolean(pkUser, CONSOLE_ITEM_HEADER[ciProcedure], false) or MyUser.HasRole('MD ADMINISTRATOR') then
        begin
          LoadProcedureValues(aXMLNode, aUpdate);
          MyDBConnection.ExecCommand(fCommandName, fParams);
        end
        else
        begin
          MessageDlg508(Format('You do not have the appropriate authorization to install %S.', [CONSOLE_ITEM_HEADER[ciProcedure]]),
            mtError, [mbOk], 0);
          Result := False;
          Exit;
        end;
      end;
    ciInstrument:
      begin
        if AccessList.ReadBoolean(pkUser, CONSOLE_ITEM_HEADER[ciInstrument], false) or MyUser.HasRole('MD ADMINISTRATOR') then
        begin
          LoadInstrumentValues(aXMLNode, aUpdate);
          MyDBConnection.ExecCommand(fCommandName, fParams);
        end
        else
        begin
          MessageDlg508(Format('You do not have the appropriate authorization to install %S.', [CONSOLE_ITEM_HEADER[ciInstrument]]),
            mtError, [mbOk], 0);
          Result := False;
          Exit;
        end;
      end;
    ciMappingTable:
      begin
        if AccessList.ReadBoolean(pkUser, CONSOLE_ITEM_HEADER[ciMappingTable], false) or MyUser.HasRole('MD ADMINISTRATOR') then
        begin
          LoadMappingTableValues(aXMLNode, aUpdate);
          MyDBConnection.ExecCommand(fCommandName, fParams);

          {Clear out and load new keys}
          MyDBConnection.ExecCommand('DeleteMappingTableTerms', [aID]);
          aSubNode := aXMLNode.ChildNodes.FindNode('TERMS');
          if Assigned(aSubNode) then
            begin
              aSubNode := aSubNode.ChildNodes.First;
              while Assigned(aSubNode) do
                begin
                  LoadMappingTableTermValues(aSubNode, aID);
                  MyDBConnection.ExecCommand(fCommandName, fParams);
                  aSubNode := aSubNode.NextSibling;
                end;
            end;
        end
        else
        begin
          MessageDlg508(Format('You do not have the appropriate authorization to install %S.', [CONSOLE_ITEM_HEADER[ciMappingTable]]),
            mtError, [mbOk], 0);
          Result := False;
          Exit;
        end;
      end;
    ciFlowsheetView:
      begin
        if AccessList.ReadBoolean(pkUser, CONSOLE_ITEM_HEADER[ciFlowsheetView], false)  or MyUser.HasRole('MD ADMINISTRATOR') then
        begin
          LoadViewValues(aXMLNode, aUpdate);
          MyDBConnection.ExecCommand(fCommandName, fParams);


          {Clear out and load new terms}
          MyDBConnection.ExecCommand('DeleteFlowsheetViewTerms', [aID]);
          aSubNode := aXMLNode.ChildNodes.FindNode('TERMINOLOGY');
          if Assigned(aSubNode) then
            begin
              aSubNode := aSubNode.ChildNodes.First;
              while Assigned(aSubNode) do
                begin
                  LoadViewTerminologyValues(aSubNode);
                  MyDBConnection.ExecCommand(fCommandName, fParams);
                  aSubNode := aSubNode.NextSibling;
                end;
            end;

          {Clear out and load new filters}
          MyDBConnection.ExecCommand('DeleteFlowsheetViewFilters', [aID]);
          aSubNode := aXMLNode.ChildNodes.FindNode('FILTERS');
          if Assigned(aSubNode) then
            begin
              aSubNode := aSubNode.ChildNodes.First;
              while Assigned(aSubNode) do
                begin
                  LoadViewFilterValues(aSubNode);
                  MyDBConnection.ExecCommand(fCommandName, fParams);
                  aSubNode := aSubNode.NextSibling;
                end;
            end;
        end
        else
        begin
          MessageDlg508(Format('You do not have the appropriate authorization to install %S.', [CONSOLE_ITEM_HEADER[ciFlowsheetView]]),
            mtError, [mbOk], 0);
          Result := False;
          Exit;
        end;
      end;
  else
    raise Exception.Create('Invalid component type specification');
  end;
  result := true;
end;

procedure TfrmXMLImport.acFinishExecute(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TfrmXMLImport.acCancelExecute(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

function TfrmXMLImport.DoesItemExist(aItemType: TCPItemType; aItemID: string): boolean;
var
  aNewXMLDoc: IXMLDocument;
  aQueryName: string;
begin
  case aItemType of
    ciProcedure: aQueryName := 'ExportProcedure';
    ciInstrument: aQueryName := 'ExportInstrument';
    ciMappingTable: aQueryName := 'ExportMappingTable';
    ciFlowsheetView: aQueryName := 'ExportView';
  else
    raise Exception.Create('Invalid Item Type');
  end;

  aNewXMLDoc := NewXMLDocument;
  if MyDBConnection.ExecQuery(aQueryName, [aItemID], aNewXMLDoc) then
    Result := Assigned(XMLDocumentFirstRecord(aNewXMLDoc))
  else
    Result := False;
end;

function TfrmXMLImport.LoadInstrumentValues(aXMLNode: IXMLNode; aUpdateExisting: boolean): boolean;
begin
  if aUpdateExisting then
    fCommandName := 'ImportInstrumentExisting'
  else
    fCommandName := 'ImportInstrumentNew';

  SetLength(fParams, 18);
  fParams[0] := aXMLNode.Attributes['ID'];
  fParams[1] := XMLValueAsStr(aXMLNode, 'NAME');
  fParams[2] := XMLValueAsStr(aXMLNode, 'DESCRIPTION');
  fParams[3] := XMLValueAsStr(aXMLNode, 'PRINTABLE_NAME');
  fParams[4] := XMLValueAsStr(aXMLNode, 'PROCESSING_ROUTINE');
  fParams[5] := XMLValueAsStr(aXMLNode, 'PROCESSING_CODE');
  fParams[6] := XMLValueAsStr(aXMLNode, 'BI-DIRECTIONAL');
  fParams[7] := XMLValueAsStr(aXMLNode, 'HL7_INSTRUMENT_ID');
  fParams[8] := XMLValueAsStr(aXMLNode, 'HL7_UNIVERSAL_SERVICE_ID');
  fParams[9] := XMLValueAsStr(aXMLNode, 'HL7_LOGICAL_LINK');
  fParams[10] := XMLValueAsStr(aXMLNode, 'PROCESS_UNC');
  fParams[11] := XMLValueAsStr(aXMLNode, 'PROCESS_TEXT');
  fParams[12] := XMLValueAsStr(aXMLNode, 'PROCESS_URL');
  fParams[13] := XMLValueAsStr(aXMLNode, 'PROCESS_DLL');
  fParams[14] := XMLValueAsStr(aXMLNode, 'PROCESS_UUENCODE');
  fParams[15] := XMLValueAsStr(aXMLNode, 'PROCESS_XML');
  fParams[16] := XMLValueAsStr(aXMLNode, 'PROCESS_XMS');
  fParams[17] := 0; {Active is Always set to false for new instruments}
  result := true;
end;

function TfrmXMLImport.LoadProcedureValues(aXMLNode: IXMLNode; aUpdateExisting: boolean): boolean;
begin
  if aUpdateExisting then
    fCommandName := 'ImportProcedureExisting'
  else
    fCommandName := 'ImportProcedureNew';

  SetLength(fParams, 9);
  fParams[0] := aXMLNode.Attributes['ID'];
  fParams[1] := XMLValueAsStr(aXMLNode, 'NAME');
  fParams[2] := XMLValueAsStr(aXMLNode, 'DESCRIPTION');
  fParams[3] := XMLValueAsStr(aXMLNode, 'PROCESSING_APPLICATION');
  fParams[4] := XMLValueAsStr(aXMLNode, 'PROCESSED_RESULT');
  fParams[5] := XMLValueAsStr(aXMLNode, 'REQUIRE_EXTERNAL_DATA');
  fParams[6] := XMLValueAsStr(aXMLNode, 'AUTO_SUBMIT');
  fParams[7] := XMLValueAsStr(aXMLNode, 'HIGH_VOLUME');
  fParams[8] := 0; {Active is Always set to false for new procedures}
  result := true;
end;

function TfrmXMLImport.LoadViewValues(aXMLNode: IXMLNode; aUpdateExisting: boolean): boolean;
begin
  if aUpdateExisting then
    fCommandName := 'ImportViewExisting'
  else
    fCommandName := 'ImportViewNew';

  SetLength(fParams, 8);
  fParams[0] := aXMLNode.Attributes['ID'];
  fParams[1] := XMLValueAsStr(aXMLNode, 'NAME');
  fParams[2] := XMLValueAsStr(aXMLNode, 'TIME_INTERVAL');
  fParams[3] := XMLValueAsStr(aXMLNode, 'X_AXIS');
  fParams[4] := XMLValueAsStr(aXMLNode, 'DISPLAY_NAME');
  fParams[5] := XMLValueAsStr(aXMLNode, 'ALLOW_PIVOT');
  fParams[6] := XMLValueAsStr(aXMLNode, 'COMMENT');
  fParams[7] := XMLValueAsInt(aXMLNode, 'NATIONAL_TITLE', 0);
  result := true;
end;

function TfrmXMLImport.LoadViewFilterValues(aXMLNode: IXMLNode): boolean;
begin
  fCommandName := 'ImportViewFilter';

  SetLength(fParams, 5);
  fParams[0] := XMLValueAsStr(aXMLNode, 'VIEW_ID');
  fParams[1] := XMLValueAsStr(aXMLNode, 'TERM_ORDER');
  fParams[2] := XMLValueAsStr(aXMLNode, 'FILTER_TYPE');
  fParams[3] := XMLValueAsStr(aXMLNode, 'FILTER_TERM');
  fParams[4] := XMLValueAsStr(aXMLNode, 'FILTER_USAGE');
  result := true;
end;

function TfrmXMLImport.LoadViewTerminologyValues(aXMLNode: IXMLNode): boolean;
begin
  fCommandName := 'ImportViewTerm';

  SetLength(fParams, 15);
  fParams[0] := XMLValueAsStr(aXMLNode, 'VIEW_ID');
  fParams[1] := XMLValueAsStr(aXMLNode, 'TERM_ORDER');
  fParams[2] := XMLValueAsStr(aXMLNode, 'TERM_ID');
  fParams[3] := XMLValueAsStr(aXMLNode, 'DISPLAY_NAME');
  fParams[4] := XMLValueAsStr(aXMLNode, 'DISPLAY_WIDTH');
  fParams[5] := XMLValueAsStr(aXMLNode, 'DISPLAY_TOTAL');
  fParams[6] := XMLValueAsStr(aXMLNode, 'DISPLAY_COUNT');
  fParams[7] := XMLValueAsStr(aXMLNode, 'DISPLAY_AVERAGE');
  fParams[8] := XMLValueAsStr(aXMLNode, 'DISPLAY_ONLY');
  fParams[9] := XMLValueAsStr(aXMLNode, 'DISPLAY_COLUMNS');
  fParams[10] := XMLValueAsStr(aXMLNode, 'DISPLAY_IN_CELL_TOTAL');
  fParams[11] := XMLValueAsStr(aXMLNode, 'DISPLAY_MINIMUM');
  fParams[12] := XMLValueAsStr(aXMLNode, 'DISPLAY_MAXIMUM');
  fParams[13] := XMLValueAsStr(aXMLNode, 'REQUIRED_TERM');
  fParams[14] := XMLValueAsStr(aXMLNode, 'USE_DROPDOWN');
  Result := true;
end;

function TfrmXMLImport.LoadMappingTableValues(aXMLNode: IXMLNode; aUpdateExisting: boolean): boolean;
begin
  if aUpdateExisting then
    fCommandName := 'UpdateMappingTable'
  else
    fCommandName := 'AddMappingTable';

  SetLength(fParams, 7);
  fParams[0] := aXMLNode.Attributes['ID'];
  fParams[1] := XMLValueAsStr(aXMLNode, 'NAME');
  fParams[2] := XMLValueAsStr(aXMLNode, 'ACTIVE');
  fParams[3] := XMLValueAsStr(aXMLNode, 'COMMENT');
  fParams[4] := XMLValueAsStr(aXMLNode, 'SOURCE_ID');
  fParams[5] := XMLValueAsStr(aXMLNode, 'SOURCE_APPLICATION');
  fParams[6] := XMLValueAsStr(aXMLNode, 'SOURCE_VERSION');
  result := true;
end;

function TfrmXMLImport.LoadMappingTableTermValues(aXMLNode: IXMLNode; aTableID: string): boolean;
begin
  fCommandName := 'AddMappingTableTerm';

  SetLength(fParams, 5);
  //fParams[0] := XMLValueAsStr(aXMLNode, 'MAPPING_TABLE_ID');
  fParams[0] := aTableID;
  fParams[1] := XMLValueAsStr(aXMLNode, 'VENDOR_KEY');
  fParams[2] := XMLValueAsStr(aXMLNode, 'TERM_TYPE');
  fParams[3] := XMLValueAsStr(aXMLNode, 'TERM');
  fParams[4] := XMLValueAsStr(aXMLNode, 'PARSER_KEY');
  result := true;
end;

function TfrmXMLImport.ImportTerminology(aXMLNode: IXMLNode): boolean;
begin
  result := false;
end;

function TfrmXMLImport.LoadTermValues(aXMLNode: IXMLNode; aUpdateExisting: boolean): boolean;
begin
  result := false;
end;

function TfrmXMLImport.LoadTermChildValues(aXMLNode: IXMLNode): boolean;
begin
  result := false;
end;

function TfrmXMLImport.LoadTermPairValues(aXMLNode: IXMLNode): boolean;
begin
  result := false;
end;

function TfrmXMLImport.LoadTermRangeCheckValues(aXMLNode: IXMLNode): boolean;
begin
  result := false;
end;

function TfrmXMLImport.LoadTermUnitConversionValues(aXMLNode: IXMLNode): boolean;
begin
  result := false;
end;

function TfrmXMLImport.LoadTermUnitPairValues(aXMLNode: IXMLNode): boolean;
begin
  result := false;
end;

procedure TfrmXMLImport.clbxItemsKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  i: integer;
begin
  if (Key = 65) and (ssCtrl in Shift) then
    if MessageDlg508('Select all items in the list?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      for i := 0 to clbxItems.Items.Count - 1 do
        clbxItems.Checked[i] := True;
  acNext.Enabled := (clbxItems.Items.Count > 0);
end;

end.

