unit mAddItem;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 10 $  $Modtime: 5/26/09 4:01p $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Primary frame for adding a new ICPConsoleItem
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/CP Console/mAddItem.pas $
*
* $History: mAddItem.pas $
 * 
 * *****************  Version 10  *****************
 * User: Zzzzzzjuergb Date: 5/28/09    Time: 10:49a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Build 275
 * 
 * *****************  Version 9  *****************
 * User: Zzzzzzpetitd Date: 4/08/08    Time: 8:18p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 
 * *****************  Version 8  *****************
 * User: Zzzzzzpetitd Date: 9/10/07    Time: 2:22p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 
 * *****************  Version 7  *****************
 * User: Zzzzzzpetitd Date: 6/28/07    Time: 8:59p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 
 * *****************  Version 6  *****************
 * User: Zzzzzzpetitd Date: 5/01/07    Time: 11:52a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Training session May 1, 2007
 * 
 * *****************  Version 5  *****************
 * User: Zzzzzzpetitd Date: 4/25/07    Time: 8:09a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Begin Alpha Testing
 * 
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 12/11/06   Time: 1:52p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Demo released to testing and documentation
 *
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 11/22/06   Time: 7:50p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * First release to tech writers and internal team.
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 10/13/06   Time: 4:36p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Removed fileman specific rpc calls. Added a search function and made
 * the Add/Search frames non-dynamic.
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:38p
 * Created in $/CP Modernization/CliO/source/CP Console
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  ComCtrls,
  Forms,
  Dialogs,
  oCliOTypes,
  oInterfaces,
  ExtCtrls,
  StdCtrls,
  Buttons;

type
  TfraAddItem = class(TFrame)
    rgType: TRadioGroup;
    edtName: TEdit;
    Label1: TLabel;
    edtDisplayName: TEdit;
    Label2: TLabel;
    Shape1: TShape;
    lblNewItem: TLabel;
    edtComment: TEdit;
    Label3: TLabel;
    btnCreate: TButton;
    pnlItems: TPanel;
    procedure btnCreateClick(Sender: TObject);
  private
    procedure Initialize(aItem: IInterface); stdcall;
    procedure Validate(var aErrorLog: TStringList); stdcall;
  public
    { Public declarations }
  end;

function NewAddItemFrame(aParent: TWinControl): TfraAddItem;

implementation

uses
  //oFlowsheet,
  //oObservation_View,
  //oMappingTable,
  //oCPInstrument,
  fMain,
  u508Dialogs;

{$R *.dfm}

function NewAddItemFrame(aParent: TWinControl): TfraAddItem;
begin
  Result := TfraAddItem.Create(aParent);
  with Result do
    begin
      DoubleBuffered := True;
      Name := Format('f%s', [NewGUID(True)]);
      Top := aParent.ControlCount * 20;
      Parent := aParent;
      Align := alClient;
      lblNewItem.Font.Style := [fsBold];
      rgType.ItemIndex := -1;
      edtName.Text := '';
      edtDisplayName.Text := '';
      Visible := False;
    end;
end;

{ TfraAddItem }

procedure TfraAddItem.Initialize(aItem: IInterface);
begin
  rgType.ItemIndex := -1;
  edtName.Text := '';
  edtDisplayName.Text := '';
end;

procedure TfraAddItem.btnCreateClick(Sender: TObject);
var
  aNewID: string;
  //aNewFlowsheet: TFlowsheet;
  aNewView: TObservationView;
  //aNewMappingTable: TMappingTable;
  //aNewCPInstrument: TCPInstrument;
  aNode: TTreeNode;
begin
  (*
  case rgType.ItemIndex of
    0:
      begin
        aNewFlowsheet := TFlowsheet.Create;
        aNewFlowsheet.Name := edtName.Text;
        aNewFlowsheet.DisplayName := edtDisplayName.Text;
        if MyDBConnection.ExecCommand('AddFlowsheet', [aNewFlowsheet.ID, aNewFlowsheet.Name, aNewFlowsheet.DisplayName, edtComment.Text, 0]) then
          begin
            aNode := frmMain.InsertNewItem(aNewFlowsheet);
            if MessageDlg508(
              'New flowsheet ''' + edtName.Text + ''' added to the console collection.' + #13 +
              'Do you want to edit this new item?',
              mtConfirmation, [mbYes, mbNo], 0) = mrYes then
              frmMain.tv.Selected := aNode
            else
              Initialize(nil);
          end
        else
          begin
            MessageDlg508('Error inserting the new flowsheet into the database.', mtError, [mbOk], 0);
            FreeAndNil(aNewFlowsheet);
          end;
      end;
    1: {Add View}
      begin
        aNewView := TObservationView.Create;
        aNewView.setName(edtName.Text);
        aNewView.setDisplayName(edtDisplayName.Text);
        if MyDBConnection.ExecCommand('AddView', [aNewView.getID, edtName.Text, edtDisplayName.Text, 7, 1, 'New View']) then
          begin
            aNode := frmMain.InsertNewItem(aNewView);
            if MessageDlg508(
              'New view ''' + edtName.Text + ''' added to the console collection.' + #13 +
              'Do you want to edit this new item?',
              mtConfirmation, [mbYes, mbNo], 0) = mrYes then
              frmMain.tv.Selected := aNode
            else
              Initialize(nil);
          end
        else
          begin
            MessageDlg508('Error inserting the new view into the database.', mtError, [mbOk], 0);
            FreeAndNil(aNewView);
          end;
      end;
    2: {Add Mapping Table}
      begin
        aNewMappingTable := TMappingTable.Create;
        aNewMappingTable.Name := edtName.Text;
        aNewMappingTable.Comment := edtComment.Text;
        if MyDBConnection.ExecCommand(
          'AddMappingTable',
          [aNewMappingTable.ID, aNewMappingTable.Name, 0, aNewMappingTable.Comment]) then
          begin
            aNode := frmMain.InsertNewItem(aNewMappingTable);
            if MessageDlg508(
              'New mapping table ''' + edtName.Text + ''' added to the console collection.' + #13 +
              'Do you want to edit this new item?',
              mtConfirmation, [mbYes, mbNo], 0) = mrYes then
              frmMain.tv.Selected := aNode
            else
              Initialize(nil);
          end
        else
          begin
            MessageDlg508('Error inserting the new Mapping Table into the database.', mtError, [mbOk], 0);
            FreeAndNil(aNewMappingTable);
          end;
      end;
    3: {Add instrument}
      begin
        //aNewCPInstrument := TCPInstrument.Create;
        //aNewCPInstrument.
      end;
    4: {Add procedure}
      begin
      end;
  end;
  *)
end;

procedure TfraAddItem.Validate(var aErrorLog: TStringList);
begin
  if rgType.ItemIndex < 0 then
    aErrorLog.Add('Please select a ''Type of Item'' to add.');
  if edtName.Text = '' then
    aErrorLog.Add('Name is a required field.');
  if edtDisplayName.Text = '' then
    aErrorLog.Add('Display Name is a required field.');
end;

end.

