unit mEditFlowsheet;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 24 $  $Modtime: 8/04/09 5:05p $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Edits a Flowsheet
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/CP Console/mEditFlowsheet.pas $
*
* $History: mEditFlowsheet.pas $
 * 
 * *****************  Version 24  *****************
 * User: Zzzzzzpetitd Date: 8/04/09    Time: 5:12p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 
 * *****************  Version 23  *****************
 * User: Zzzzzzjuergb Date: 8/04/09    Time: 9:37a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Fixed error with loading of totals for a flowsheet in CP Console.
 * 
 * *****************  Version 22  *****************
 * User: Zzzzzzjuergb Date: 7/24/09    Time: 10:10a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Added drop-down widener.
 * 
 * *****************  Version 21  *****************
 * User: Zzzzzzjuergb Date: 6/25/09    Time: 3:14p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 508 Fixes.
 * 
 * Flowsheet totals screen: Buttons to add/remove/rearrange totals were
 * not being said correctly.
 * 
 * CP ADT Config screen: Only the caption was being read.  The whole line
 * needed to be read.
 * 
 * Added caption to icons so that JAWS can determine if they're active
 * without having to tab into the editor page.
 * 
 * Add New Flowsheet View dialog: caption for combobox was not being read.
 * 
 * *****************  Version 20  *****************
 * User: Zzzzzzjuergb Date: 5/22/09    Time: 2:17p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Build Pre-275:  
 * 
 * *****************  Version 19  *****************
 * User: Zzzzzzjuergb Date: 5/14/09    Time: 10:45a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 
 * *****************  Version 18  *****************
 * User: Zzzzzzpetitd Date: 10/14/08   Time: 11:09a
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 17  *****************
 * User: Zzzzzzpetitd Date: 6/17/08    Time: 9:04p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 16  *****************
 * User: Zzzzzzpetitd Date: 4/08/08    Time: 8:18p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 15  *****************
 * User: Zzzzzzpetitd Date: 4/06/08    Time: 3:11p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 14  *****************
 * User: Zzzzzzpetitd Date: 3/13/08    Time: 9:00p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 13  *****************
 * User: Zzzzzzpetitd Date: 3/08/08    Time: 9:51p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 12  *****************
 * User: Zzzzzzpetitd Date: 3/04/08    Time: 7:51a
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 11  *****************
 * User: Zzzzzzpetitd Date: 2/19/08    Time: 8:42p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 10  *****************
 * User: Zzzzzzpetitd Date: 10/24/07   Time: 10:31a
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 9  *****************
 * User: Zzzzzzpetitd Date: 9/10/07    Time: 2:22p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 8  *****************
 * User: Zzzzzzpetitd Date: 7/25/07    Time: 12:34p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Working on the recursive load call so that we can respond back on the
 * progress of the observation loader.
 *
 * *****************  Version 7  *****************
 * User: Zzzzzzpetitd Date: 7/06/07    Time: 10:17a
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 6  *****************
 * User: Zzzzzzpetitd Date: 6/28/07    Time: 8:59p
 * Updated in $/CP Modernization/CliO/source/CP Console
 *
 * *****************  Version 5  *****************
 * User: Zzzzzzpetitd Date: 4/25/07    Time: 8:10a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Begin Alpha Testing
 *
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 12/11/06   Time: 1:53p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Demo released to testing and documentation
 *
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 11/22/06   Time: 7:50p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * First release to tech writers and internal team.
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 10/27/06   Time: 2:24p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Implemented new ExecQuery and Role based access methods.
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:38p
 * Created in $/CP Modernization/CliO/source/CP Console
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  StdCtrls,
  oCliOTypes,
  oInterfaces,
  ActnList,
  Buttons,
  ImgList,
  ToolWin,
  ExtCtrls,
  Menus,
  XMLDoc,
  XMLIntf,
  mLookup, VA508AccessibilityManager, System.Actions, System.ImageList;

type
  TfraEditFlowsheet = class(TForm, ICPEditor)
    pnlGeneral: TPanel;
    lblComment: TLabel;
    lblDisplayName: TLabel;
    lblGeneral: TLabel;
    Shape1: TShape;
    edtComment: TEdit;
    edtDisplayName: TEdit;
    ckbxActive: TCheckBox;
    ImageList1: TImageList;
    ActionList1: TActionList;
    acPageAdd: TAction;
    acPageRemove: TAction;
    acPageMoveUp: TAction;
    acPageMoveDown: TAction;
    acPageEdit: TAction;
    fraLookupTIUNoteTitle: TfraLookup;
    Label1: TLabel;
    pnlTotals: TPanel;
    pgctrl: TPageControl;
    tbshtViews: TTabSheet;
    tbshtTotals: TTabSheet;
    acTotalAdd: TAction;
    acTotalRemove: TAction;
    acTotalMoveUp: TAction;
    acTotalMoveDown: TAction;
    acPageSelect: TAction;
    acPageRefreshList: TAction;
    pnlLeft: TPanel;
    pnlRight: TPanel;
    Label3: TLabel;
    lbxTotalsAll: TListBox;
    Label2: TLabel;
    lbxTotalsAssigned: TListBox;
    chkbxKardex: TCheckBox;
    A508Mgr: TVA508AccessibilityManager;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    lvPages: TListView;
    pnlPagesButtons: TPanel;
    btnPageMoveUp: TBitBtn;
    btnPageAdd: TBitBtn;
    btnPageEdit: TBitBtn;
    btnPageRemove: TBitBtn;
    btnMoveDown: TBitBtn;
    procedure acPageAddExecute(Sender: TObject);
    procedure acPageEditExecute(Sender: TObject);
    procedure acPageMoveUpExecute(Sender: TObject);
    procedure acPageMoveDownExecute(Sender: TObject);
    procedure acPageRemoveExecute(Sender: TObject);
    procedure acTotalAddExecute(Sender: TObject);
    procedure acTotalRemoveExecute(Sender: TObject);
    procedure acPageSelectExecute(Sender: TObject);
    procedure acPageRefreshListExecute(Sender: TObject);
    procedure tbshtTotalsResize(Sender: TObject);
    procedure acTotalMoveUpExecute(Sender: TObject);
    procedure acTotalMoveDownExecute(Sender: TObject);
    procedure lvPagesClick(Sender: TObject);
    procedure lvPagesChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
  private
    fFlowsheet: ICPFlowsheet;
    procedure LookupTIUNote(aPartial: string; aResult: TStrings);
    procedure Initialize(aItem: IInterface); stdcall;
    procedure Validate(var aErrorLog: TStringList); stdcall;
    procedure Save; stdcall;
    procedure SetReadOnly(const aValue: boolean); stdcall;
  end;

function NewEditFlowsheetFrame(aParent: TWinControl): TfraEditFlowsheet;

implementation

uses
  fMain,
  oCPTypes,
  fEditFlowsheetPage;

{$R *.dfm}

function NewEditFlowsheetFrame(aParent: TWinControl): TfraEditFlowsheet;
begin
  Result := TfraEditFlowsheet.Create(aParent);
  with Result do
    begin
      Name := Format('f%s', [NewGUID(True)]);
      Top := aParent.ControlCount * 20;
      Parent := aParent;
      Align := alClient;
      lblGeneral.Font.Style := [fsBold];
    end;
end;

{ TfraEditFlowsheet }

procedure TfraEditFlowsheet.Initialize(aItem: IInterface);
begin
  if aItem.QueryInterface(ICPFlowsheet, fFlowsheet) = 0 then
    begin
      edtDisplayName.Text := fFlowsheet.getDisplayName;
      edtComment.Text := fFlowsheet.getComment;
      ckbxActive.Checked := fFlowsheet.getActive;
      lvPages.Items.Clear;

      fFlowsheet.LoadPages(lvPages);

      chkbxKardex.Checked := fFlowsheet.getDisplayKardex;
      MyCPService.LoadList(lbxTotalsAll.Items, ciFlowsheetTotal);

      {Whoops.  This should NOT have come out}
      fFlowsheet.LoadTotals(lbxTotalsAssigned.Items);
      
      acPageRefreshList.Execute;

      fraLookupTIUNoteTitle.Initialize(
        fFlowsheet.getDefaultTIUNoteID,
        fFlowsheet.getDefaultTIUNote,
        LookupTIUNote, nil, Label1);

      pgctrl.ActivePage := tbshtViews;
      Visible := true;
    end;
end;

procedure TfraEditFlowsheet.SetReadOnly(const aValue: boolean);
begin
  Enabled := (not aValue);
end;

procedure TfraEditFlowsheet.tbshtTotalsResize(Sender: TObject);
begin
  pnlLeft.Width := tbshtTotals.Width div 2;
end;

procedure TfraEditFlowsheet.Validate(var aErrorLog: TStringList);
begin
  //
end;

procedure TfraEditFlowsheet.LookupTIUNote(aPartial: string; aResult: TStrings);
begin
  DoLookup('GetNoteTitlesPN', aPartial, 60, aResult);
end;

procedure TfraEditFlowsheet.lvPagesChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  lvPagesClick(Sender);
end;

procedure TfraEditFlowsheet.lvPagesClick(Sender: TObject);
begin
  acPageSelect.Execute;
end;

(******************************** TOTALS **************************************)

procedure TfraEditFlowsheet.acTotalAddExecute(Sender: TObject);
var
  aTotal: ICPFlowsheetTotal;
begin
  if lbxTotalsAll.ItemIndex > -1 then
    if lbxTotalsAll.Items.Objects[lbxTotalsAll.ItemIndex].GetInterface(ICPFlowsheetTotal, aTotal) then
      aTotal.AddToList(lbxTotalsAssigned.Items);
end;

procedure TfraEditFlowsheet.acTotalMoveDownExecute(Sender: TObject);
begin
  if lbxTotalsAssigned.ItemIndex < lbxTotalsAssigned.Items.Count - 1 then
    lbxTotalsAssigned.Items.Exchange(lbxTotalsAssigned.ItemIndex, lbxTotalsAssigned.ItemIndex + 1);
end;

procedure TfraEditFlowsheet.acTotalMoveUpExecute(Sender: TObject);
begin
  if lbxTotalsAssigned.ItemIndex > 0 then
    lbxTotalsAssigned.Items.Exchange(lbxTotalsAssigned.ItemIndex, lbxTotalsAssigned.ItemIndex - 1);
end;

procedure TfraEditFlowsheet.acTotalRemoveExecute(Sender: TObject);
begin
  if lbxTotalsAssigned.ItemIndex > -1 then
    lbxTotalsAssigned.DeleteSelected;
end;

(******************************** PAGES ***************************************)

procedure TfraEditFlowsheet.acPageAddExecute(Sender: TObject);
var
  aNewPage: ICPFlowsheetPage;
begin
  aNewPage := MyCPService.CreateNewCPFlowsheetPage(fFlowsheet);

  with NewEditFlowsheetPageForm(aNewPage) do
    try
      Caption := 'New Flowsheet Page';
      cbxPageType.ItemIndex := 0;
      MyCPService.LoadList(cbxView.Items, ciFlowsheetView);
      ChangeMade(nil);
      if ShowModal = mrOk then
        begin
          aNewPage.AddToListView(lvPages);
          fFlowsheet.InsertPage(aNewPage);
          acPageRefreshList.Execute;
        end;
    finally
      Free;
    end;
end;

procedure TfraEditFlowsheet.acPageEditExecute(Sender: TObject);
var
  aPage: ICPFlowsheetPage;
  oPage: TObject;
begin
  if lvPages.Selected.Index > -1 then
    begin
    oPage := TObject(lvPages.Items[lvPages.Selected.Index].Data);
    if oPage.GetInterface(ICPFlowsheetPage, aPage) then
      begin
        with NewEditFlowsheetPageForm(aPage) do
          try
            MyCPService.LoadList(cbxView.Items, ciFlowsheetView);
            cbxPageType.ItemIndex := Ord(aPage.getPageType);
            memDisplayName.Text := aPage.getDisplayName;
            memSpecialInstructions.Text := aPage.getSpecialInstructions;
            if aPage.getFlowsheetView <> nil then
              cbxView.ItemIndex := aPage.getFlowsheetView.getIndex(cbxView.Items)
            else
              cbxView.ItemIndex := -1;
            ShowModal;
            acPageRefreshList.Execute;
          finally
            Free;
          end;
      end;
    end;
end;

procedure TfraEditFlowsheet.acPageMoveDownExecute(Sender: TObject);
var
 Item: TListItem;
 SelectedIndex: Integer;
begin
  {
  Unlike the TStrings class, the TListItems class doesn't have an Exchange()
  method.  So we have to do this the hard way.
  }
  SelectedIndex := lvPages.Selected.Index;
  if SelectedIndex < (lvPages.Items.Count - 1) then
  begin
    Item := lvPages.Items.Insert(SelectedIndex + 2);
    Item.Assign(lvPages.Selected);
    lvPages.Items.Delete(SelectedIndex);
    lvPages.Selected := Item;
    lvPages.SetFocus;
  end;
  acPageSelect.Execute;
end;

procedure TfraEditFlowsheet.acPageMoveUpExecute(Sender: TObject);
var
 Item: TListItem;
 SelectedIndex: Integer;
begin
  {
  Unlike the TStrings class, the TListItems class doesn't have an Exchange()
  method.  So we have to do this the hard way.
  }
  SelectedIndex := lvPages.Selected.Index;
  if SelectedIndex > 0 then
  begin
    Item := lvPages.Items.Insert(SelectedIndex - 1);
    Item.Assign(lvPages.Selected);
    lvPages.Items.Delete(lvPages.Selected.Index);
    lvPages.Selected := Item;
    lvPages.SetFocus;
  end;
  acPageSelect.Execute;
end;

procedure TfraEditFlowsheet.acPageRefreshListExecute(Sender: TObject);
var
  aPage: ICPFlowsheetPage;
  oPage: TObject;
  Enum: TListItemsEnumerator;
begin
  Enum := lvPages.Items.GetEnumerator;
  try
    while Enum.MoveNext do
    begin
      oPage := (Enum.Current.Data);
      if oPage.GetInterface(ICPFlowsheetPage, aPage) then
      begin
        Enum.Current.Caption := Format('%s (%s)', [aPage.getFlowsheetViewName,
          Copy(CP_FLOWSHEET_PAGE_TYPE[aPage.getPageType], 1, 1)]);
        Enum.Current.SubItems.Add(Format('%s', [aPage.getDisplayName]));
      end;
    end;
  finally
    FreeAndNil(Enum);
  end;
end;

procedure TfraEditFlowsheet.acPageRemoveExecute(Sender: TObject);
var
  aPage: ICPFlowsheetPage;
begin
  if lvPages.ItemIndex > -1 then
    begin
      if TObject(lvPages.Items[lvPages.ItemIndex].Data).GetInterface(ICPFlowsheetPage, aPage) then
        fFlowsheet.RemovePage(aPage);
      lvPages.DeleteSelected;
    end;
end;

procedure TfraEditFlowsheet.acPageSelectExecute(Sender: TObject);
begin
  acPageEdit.Enabled := (lvPages.ItemIndex > -1);
  acPageRemove.Enabled := (lvPages.ItemIndex > -1);
  acPageMoveUp.Enabled := (lvPages.ItemIndex > 0);
  acPageMoveDown.Enabled := (lvPages.ItemIndex < lvPages.Items.Count - 1);
end;

procedure TfraEditFlowsheet.Save;
var
  i: integer;
  aPage: ICPFlowsheetPage;
  aTotal: ICPFlowsheetTotal;
  Enum: TListItemsEnumerator;
begin
  fFlowsheet.setActive(ckbxActive.Checked);
  fFlowsheet.setComment(edtComment.Text);
  fFlowsheet.setDisplayName(edtDisplayName.Text);
  fFlowsheet.setDefaultTIUNoteID(fraLookupTIUNoteTitle.InternalValue);
  fFlowsheet.setDefaultTIUNote(fraLookupTIUNoteTitle.ExternalValue);
  fFlowsheet.setDisplayKardex(chkbxKardex.Checked);

  Enum := lvPages.Items.GetEnumerator;
  try
    while Enum.MoveNext do
    begin
      if TObject(Enum.GetCurrent.Data).GetInterface(ICPFlowsheetPage, aPage) then
        aPage.setPageOrder(Enum.GetCurrent.Index + 1);
    end;
  finally
    FreeAndNil(Enum);
  end;

  fFlowsheet.ClearTotals;
  for i := 0 to lbxTotalsAssigned.Items.Count - 1 do
    if lbxTotalsAssigned.Items.Objects[i].GetInterface(ICPFlowsheetTotal, aTotal) then
      fFlowsheet.InsertTotal(aTotal);

  fFlowsheet.Save;
end;

end.

