unit mEditFlowsheetPage;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 5 $  $Modtime: 5/20/09 1:44p $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Repeating frame for editing flowsheet pages.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/CP Console/mEditFlowsheetPage.pas $
*
* $History: mEditFlowsheetPage.pas $
 * 
 * *****************  Version 5  *****************
 * User: Zzzzzzjuergb Date: 5/22/09    Time: 2:17p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Build Pre-275:  
 * 
 * *****************  Version 4  *****************
 * User: Zzzzzzjuergb Date: 5/14/09    Time: 10:45a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 7/06/07    Time: 10:17a
 * Updated in $/CP Modernization/CliO/source/CP Console
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 12/11/06   Time: 1:53p
 * Updated in $/CP Modernization/CliO/source/CP Console
 * Demo released to testing and documentation
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:39p
 * Created in $/CP Modernization/CliO/source/CP Console
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  oInterfaces,
  XMLIntf,
  Dialogs,
  StdCtrls,
  ExtCtrls, VA508AccessibilityManager;

type
  TfraEditFlowsheetPage = class(TForm)
    lblView: TLabel;
    cbxView: TComboBox;
    edtDisplayName: TEdit;
    Label2: TLabel;
    rgPageType: TRadioGroup;
    Shape2: TShape;
    Panel1: TPanel;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
  private
    {}
  public
    procedure Save(aFlowsheetID: string; aPageOrder: integer; aDBCOnnection: IDBCOnnection);
    procedure Initialize(aXMLNode: IXMLNode);
  end;

function NewEditFlowsheetPageFrame(aParent: TWinControl): TfraEditFlowsheetPage;

implementation

uses
  uCPXML;

{$R *.dfm}

function NewEditFlowsheetPageFrame(aParent: TWinControl): TfraEditFlowsheetPage;
begin
  Result := TfraEditFlowsheetPage.Create(aParent);
  with Result do
    begin
      Name := Format('%s_%d', [Result.ClassName, aParent.ControlCount]);
      Top := aParent.ComponentCount * Height;
      Parent := aParent;
      Align := alTop;
      lblView.Font.Style := [fsBold];
      rgPageType.ItemIndex := 0;
      edtDisplayName.Text := '';
    end;
end;

{ TfraEditFlowsheetPage }

procedure TfraEditFlowsheetPage.Initialize(aXMLNode: IXMLNode);
var
  i: integer;
  aView: ICPConsoleItem;
begin
  for i := 0 to cbxView.Items.Count - 1 do
    if cbxView.Items.Objects[i].GetInterface(ICPConsoleItem, aView) then
      if aView.getID = XMLValueAsStr(aXMLNode, 'VIEW_ID') then
        cbxView.ItemIndex := i;
  edtDisplayName.Text := XMLValueAsStr(aXMLNode, 'DISPLAY_NAME');
  rgPageType.ItemIndex := XMLValueAsInt(aXMLNode, 'PAGE_TYPE');
  Visible := true;
end;

procedure TfraEditFlowsheetPage.Save(aFlowsheetID: string; aPageOrder: integer; aDBCOnnection: IDBCOnnection);
var
  aView: ICPConsoleItem;
begin
  if cbxView.ItemIndex > -1 then
    if cbxView.Items.Objects[cbxView.ItemIndex].GetInterface(ICPConsoleItem, aView) then
      if not aDBCOnnection.ExecCommand(
        'AddFlowsheetPage',
        [aFlowsheetID, aPageOrder, aView.getID, rgPageType.ItemIndex, edtDisplayName.Text]) then
        raise Exception.CreateFmt('Error saving flowsheet page %d', [aPageOrder]);
end;

end.
