unit mEditObservationViewFilter;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 10 $  $Modtime: 7/24/09 9:29a $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Repeating frame for each filter term in a view.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/CP Console/mEditObservationViewFilter.pas $
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  oCliOTypes,
  oInterfaces,
  StdCtrls,
  ExtCtrls, VA508AccessibilityManager;

type
  TfraEditObservationViewFilter = class(TForm)
    cbxFilter: TComboBox;
    chkbxAsk: TCheckBox;
    chkbxMandatory: TCheckBox;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure chkbxAskClick(Sender: TObject);
    procedure cbxFilterKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure cbxFilterChange(Sender: TObject);
    procedure cbxFilterDropDown(Sender: TObject);
  private
    fFilterType: TTermType;
    { Private declarations }
  public
    procedure setFilterType(aFilterType: TTermType);
    procedure SetObsEnabled(aValue: Boolean);
    procedure SetFilter(aFilterID: string; aFilterMandatory: Boolean);
    procedure Save(aViewID: string; aTermOrder: integer; aFilterType: TTermType; aDBConnection: IDBConnection);
    { Public declarations }
  end;

function NewEditObservationViewFilterFrame(aParent: TWinControl): TfraEditObservationViewFilter;

implementation

uses
  uCP_GUI;

{$R *.dfm}

function NewEditObservationViewFilterFrame(aParent: TWinControl): TfraEditObservationViewFilter;
begin
  Result := TfraEditObservationViewFilter.Create(aParent);
  with Result do
    begin
      if aParent is TForm then
        Result.Color := (aParent as TForm).Color;
      Name := Format('%s_%d', [Result.ClassName, aParent.ControlCount]);
      Top := 0; //aParent.ComponentCount * Height;
      Parent := aParent;
      Visible := False;
      //Align := alTop;
    end;
end;

{ TfraEditObservationViewFilter }

procedure TfraEditObservationViewFilter.Save(aViewID: string; aTermOrder: integer; aFilterType: TTermType; aDBConnection: IDBConnection);
begin
end;

procedure TfraEditObservationViewFilter.SetObsEnabled(aValue: Boolean);
begin
  //
end;

procedure TfraEditObservationViewFilter.SetFilter(aFilterID: string; aFilterMandatory: Boolean);
begin
end;

procedure TfraEditObservationViewFilter.setFilterType(aFilterType: TTermType);
begin
  fFilterType := aFilterType;
  chkbxAsk.Caption := QUALNAME[fFilterType];
end;

procedure TfraEditObservationViewFilter.chkbxAskClick(Sender: TObject);
begin
  if not chkbxAsk.Checked then
    begin
      cbxFilter.ItemIndex := -1;
      cbxFilter.Enabled := False;
      chkbxMandatory.Checked := False;
      chkbxMandatory.Enabled := False;
    end
  else
    begin
      cbxFilter.Enabled := True;
    end;
end;

procedure TfraEditObservationViewFilter.cbxFilterChange(Sender: TObject);
begin
  chkbxMandatory.Enabled := (cbxFilter.ItemIndex > -1);
end;

procedure TfraEditObservationViewFilter.cbxFilterDropDown(Sender: TObject);
begin
  SetDropDownWidth(cbxFilter);
end;

procedure TfraEditObservationViewFilter.cbxFilterKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    begin
      cbxFilter.ItemIndex := -1;
      chkbxMandatory.Checked := False;
      chkbxMandatory.Enabled := False;
    end;
end;

end.

