unit mGatewayAdmin;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 1 $  $Modtime: 6/19/07 9:45a $
*       Developer:    brian.juergensmeyer@va.gov
*       Site:         Hines OIFO
*
*       Description:  UI for CP Gateway Administrator.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/CP Console/mGatewayAdmin.pas $
================================================================================
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, ExtCtrls, StdCtrls, Mask, oInterfaces, oCliO, Spin;

type
  TfraGatewayAdmin = class(TFrame, ICPEditor)
    Shape1: TShape;
    lblAccessVerifyCodes: TLabel;
    Panel1: TPanel;
    meVerifyCode: TMaskEdit;
    meAccessCode: TMaskEdit;
    Label2: TLabel;
    Label3: TLabel;
    lblVistAServerAddress: TLabel;
    Shape2: TShape;
    Panel2: TPanel;
    Label1: TLabel;
    edtIPAddress: TEdit;
    Label4: TLabel;
    meBrokerPort: TMaskEdit;
    meNotifyPort: TMaskEdit;
    Label5: TLabel;
    seLogLevel: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    edtLogDirectory: TEdit;
  private
    { Private declarations }
    FConfig: ICPGatewayAdmin;
  public
    { Public declarations }
    procedure Initialize(aItem: IInterface); stdcall;
    procedure Save; stdcall;
    procedure Validate(var aErrorLog: TStringList); stdcall;
  end;

function NewGatewayAdminFrame(aParent: TWinControl): TfraGatewayAdmin;


implementation

uses
  oCliOTypes;

{$R *.dfm}

function NewGatewayAdminFrame(aParent: TWinControl): TfraGatewayAdmin;
begin
  Result := TfraGatewayAdmin.Create(aParent);
  with Result do
    begin
      Name := Format('f%s', [NewGUID]);
      Top := aParent.ControlCount * 20;
      Parent := aParent;
      Align := alClient;
      lblAccessVerifyCodes.Font.Style := [fsBold];
      lblVistAServerAddress.Font.Style := [fsBold];
    end;
end;

{ TfraGatewayAdmin }

procedure TfraGatewayAdmin.Initialize(aItem: IInterface);
begin
  if aItem.QueryInterface(ICPGatewayAdmin, FConfig) = 0 then
  begin
    meAccessCode.Text := FConfig.getEncryptedAccess;
    meVerifyCode.Text := FConfig.getEncryptedVerify;
    edtIPAddress.Text := FConfig.getServerIP;
    meBrokerPort.Text := IntToStr(FConfig.getBrokerPort);
    meNotifyPort.Text := IntToStr(FConfig.getNotifyPort);
    seLogLevel.Value := FConfig.getLogLevel;
    edtLogDirectory.Text := FConfig.getLogFileDirectory;
  end;
end;

procedure TfraGatewayAdmin.Save;
begin
  FConfig.setAccessCode(meAccessCode.Text);
  FConfig.setVerifyCode(meVerifyCode.Text);
  FConfig.setServerIP(edtIPAddress.Text);
  FConfig.setBrokerPort(StrToIntDef(meBrokerPort.Text,0));
  FConfig.setNotifyPort(StrToIntDef(meNotifyPort.Text,0));
  FConfig.setLogLevel(seLogLevel.Value);
  FConfig.setLogFileDirectory(edtLogDirectory.Text);   
  FConfig.Save;
end;

procedure TfraGatewayAdmin.Validate(var aErrorLog: TStringList);
begin

end;

end.
