unit mSearch;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 6 $  $Modtime: 5/20/09 1:51p $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Find a ICPConsole Item.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/CP Console/mSearch.pas $
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  StdCtrls,
  ExtCtrls,
  oInterfaces,
  oCPTypes,
  oCliOTypes, VA508AccessibilityManager;

type
  TfraSearch = class(TForm)
    Shape1: TShape;
    lblGeneral: TLabel;
    edtSearchFor: TEdit;
    btnSearch: TButton;
    Label1: TLabel;
    Label2: TLabel;
    lvSearch: TListView;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure btnSearchClick(Sender: TObject);
    procedure lvSearchClick(Sender: TObject);
    procedure lvSearchKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function NewSearchFrame(aParent: TWinControl): TfraSearch;

implementation

uses fMain;

{$R *.dfm}

function NewSearchFrame(aParent: TWinControl): TfraSearch;
begin
  Result := TfraSearch.Create(aParent);
  with Result do
    begin
      Name := Format('f%s', [NewGUID(True)]);
      Top := aParent.ControlCount * 20;
      Parent := aParent;
      Align := alClient;
      lblGeneral.Font.Style := [fsBold];
      Visible := True;
    end;
end;

procedure TfraSearch.btnSearchClick(Sender: TObject);
var
  i: integer;
  aItem: ICPConsoleItem;
begin
  lvSearch.Items.Clear;
  with frmMain.tv do
    for i := 0 to Items.Count - 1 do
      if Pos(LowerCase(edtSearchFor.Text), LowerCase(Items[i].Text)) > 0 then
        if Items[i].Data <> nil then
          if TObject(Items[i].Data).GetInterface(ICPConsoleItem, aItem) then
            with lvSearch.Items.Add do
              begin
                Caption := aItem.getName;
                SubItems.Add(CONSOLE_ITEM_HEADER[aItem.getItemType]);
                SubItems.Add(aItem.getComment);
                Data := TTreeNode(Items[i]); {Store the node here}
              end;
  aItem := nil; {Forces the release to the object}
end;

procedure TfraSearch.lvSearchClick(Sender: TObject);
begin
  if lvSearch.Selected <> nil then
    if lvSearch.Selected.Data <> nil then
      frmMain.tv.Selected := TTreeNode(lvSearch.Selected.Data);
end;

procedure TfraSearch.lvSearchKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
    lvSearchClick(Sender);
end;

end.

