program CliO;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 38 $  $Modtime: 2/11/09 3:45p $
*       Developer:    doma.user@domain.ext
*       Site:         Hines OIFO
*
*       Description:
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/CliO/CliO.dpr $
================================================================================
}
uses
  Forms,
  fMainCliO in 'fMainCliO.pas' {frmCliOMain},
  oCliOTypes in '..\Common\objects\oCliOTypes.pas',
  oDBConnection_ADO in '..\Common\objects\oDBConnection_ADO.pas',
  oDBConnection_Cache in '..\Common\objects\oDBConnection_Cache.pas',
  oDBConnection_J2EE in '..\Common\objects\oDBConnection_J2EE.pas',
  oDBConnection_MSAccess in '..\Common\objects\oDBConnection_MSAccess.pas',
  oDBConnection_VistA in '..\Common\objects\oDBConnection_VistA.pas',
  oDBController in '..\Common\objects\oDBController.pas',
  oDBController_CPConsole in '..\Common\objects\oDBController_CPConsole.pas',
  oDBController_Observations in '..\Common\objects\oDBController_Observations.pas',
  oDBController_Patient in '..\Common\objects\oDBController_Patient.pas',
  oDBController_Terminology in '..\Common\objects\oDBController_Terminology.pas',
  oFileManField in '..\Common\objects\oFileManField.pas',
  oInterfaces in '..\Common\objects\oInterfaces.pas',
  oObservation in '..\Common\objects\oObservation.pas',
  oObservation_Battery in '..\Common\objects\oObservation_Battery.pas',
  oObservation_Documentor in '..\Common\objects\oObservation_Documentor.pas',
  oCliOFiler in '..\Common\objects\oCliOFiler.pas',
  oCliOLoader in '..\Common\objects\oCliOLoader.pas',
  oObservation_Validator in '..\Common\objects\oObservation_Validator.pas',
  oTerm in '..\Common\objects\oTerm.pas',
  oVersionInformation in '..\Common\objects\oVersionInformation.pas',
  uRegistryFunc in '..\Common\utilities\uRegistryFunc.pas',
  uServiceFunc in '..\Common\utilities\uServiceFunc.pas',
  oObservation_Correction in '..\Common\objects\oObservation_Correction.pas',
  uConversions in '..\Common\utilities\uConversions.pas',
  oTermConversion in '..\Common\objects\oTermConversion.pas',
  oTermMapper in '..\Common\objects\oTermMapper.pas',
  uCP_GUI in '..\Common\utilities\uCP_GUI.pas',
  oObservation_Report in '..\Common\objects\oObservation_Report.pas',
  oCliOList in '..\Common\objects\oCliOList.pas',
  oCliOFilerDoc in '..\Common\objects\oCliOFilerDoc.pas',
  oCliOFilerObs in '..\Common\objects\oCliOFilerObs.pas',
  oObservation_Audit in '..\Common\objects\oObservation_Audit.pas',
  oTermUnit in '..\Common\objects\oTermUnit.pas',
  oTerm_Range_Check in '..\Common\objects\oTerm_Range_Check.pas',
  oTermChild in '..\Common\objects\oTermChild.pas',
  oCliOFilerSet in '..\Common\objects\oCliOFilerSet.pas',
  oCliO in '..\Common\objects\oCliO.pas',
  oCliOHL7LogEntry in '..\Common\objects\oCliOHL7LogEntry.pas',
  oCliOHL7Log in '..\Common\objects\oCliOHL7Log.pas',
  oCliOParameterFile in '..\Common\objects\oCliOParameterFile.pas',
  oCP_Exceptions in '..\Common\objects\oCP_Exceptions.pas',
  oCPBackgroundTask in '..\Common\objects\oCPBackgroundTask.pas',
  oCPFlowsheet in '..\Common\objects\oCPFlowsheet.pas',
  oCPFlowsheetPage in '..\Common\objects\oCPFlowsheetPage.pas',
  oCPGatewayConfig in '..\Common\objects\oCPGatewayConfig.pas',
  oCPGatewayTest in '..\Common\objects\oCPGatewayTest.pas',
  oCPInstrument in '..\Common\objects\oCPInstrument.pas',
  oCPParameterFile in '..\Common\objects\oCPParameterFile.pas',
  oCPParameters in '..\Common\objects\oCPParameters.pas',
  oCPPatient in '..\Common\objects\oCPPatient.pas',
  oCPProcedure in '..\Common\objects\oCPProcedure.pas',
  oCPTypes in '..\Common\objects\oCPTypes.pas',
  oCPUser in '..\Common\objects\oCPUser.pas',
  uCPXML in '..\Common\utilities\uCPXML.pas',
  oTrackableInterfacedObject in '..\Common\objects\oTrackableInterfacedObject.pas',
  oCPUserOptions in '..\Common\objects\oCPUserOptions.pas',
  oCliOAlarm in '..\Common\objects\oCliOAlarm.pas',
  oCliOAlarmList in '..\Common\objects\oCliOAlarmList.pas',
  oCliOReport in '..\Common\objects\oCliOReport.pas',
  oDBController_CPKardex in '..\Common\objects\oDBController_CPKardex.pas',
  oCPKardexAction in '..\Common\objects\oCPKardexAction.pas',
  oCPKardexEvent in '..\Common\objects\oCPKardexEvent.pas',
  oCPLocation in '..\Common\objects\oCPLocation.pas',
  oCPShift in '..\Common\objects\oCPShift.pas',
  oHL7Message in '..\Common\objects\oHL7Message.pas',
  uParser in '..\Common\utilities\uParser.pas',
  oTermPair in '..\Common\objects\oTermPair.pas',
  oCliOLogEntry in '..\Common\objects\oCliOLogEntry.pas',
  oCPTIUDocument in '..\Common\objects\oCPTIUDocument.pas',
  oCPFlowsheetTotal in '..\Common\objects\oCPFlowsheetTotal.pas',
  oCPAccessControlListItem in '..\Common\objects\oCPAccessControlListItem.pas',
  oDBController_Person in '..\Common\objects\oDBController_Person.pas',
  oCPPerson in '..\Common\objects\oCPPerson.pas',
  oCPAccessControlList in '..\Common\objects\oCPAccessControlList.pas',
  fPersonLookup in '..\Common\forms\fPersonLookup.pas' {frmPersonLookup},
  oCPFlowsheetView in '..\Common\objects\oCPFlowsheetView.pas',
  oCPFlowsheetViewTerm in '..\Common\objects\oCPFlowsheetViewTerm.pas',
  oCPProtocolLocation in '..\Common\objects\oCPProtocolLocation.pas',
  oGateway in '..\Common\objects\oGateway.pas',
  fSplash in '..\Common\forms\fSplash.pas' {frmSplash},
  fAboutDlg in '..\Common\forms\fAboutDlg.pas' {frmAboutDlg},
  fComment in '..\Common\forms\fComment.pas' {frmGetComment},
  oCPSchedule in '..\Common\objects\oCPSchedule.pas',
  oCPKardexAudit in '..\Common\objects\oCPKardexAudit.pas',
  fLogDisplay in '..\Common\forms\fLogDisplay.pas' {frmLogDisplay},
  fTimeOutManager in '..\Common\forms\fTimeOutManager.pas' {frmTimeOutManager},
  uWordDoc in '..\Common\utilities\uWordDoc.pas',
  uCCOW in '..\Common\utilities\uCCOW.pas',
  oCPEmailMessage in '..\Common\objects\oCPEmailMessage.pas',
  u508Dialogs in '..\Common\utilities\u508Dialogs.pas' {frmMessageDlg508},
  u508Func in '..\Common\utilities\u508Func.pas';

{$R *.res}

begin
  Application.Initialize;
  Application.CreateForm(TfrmCliOMain, frmCliOMain);
  Application.CreateForm(TfrmSplash, frmSplash);
  Application.Run;
end.

