unit fComment;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmGetComment = class(TForm)
    btnCancel: TButton;
    btnOK: TButton;
    Panel1: TPanel;
    lblPrompt: TLabel;
    memComment: TMemo;
    lblParams: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure memCommentChange(Sender: TObject);
  private
    fMin: integer;
    fMax: integer;
    { Private declarations }
  public
    { Public declarations }
  end;

function GetComment(var aComment: string; aCaption: string = 'Comment'; aPrompt: string = 'Comment:'; aMinLen: integer = 5; aMaxLen: integer = 200): boolean;

implementation

{$R *.dfm}

function GetComment(var aComment: string; aCaption: string = 'Comment'; aPrompt: string = 'Comment:'; aMinLen: integer = 5; aMaxLen: integer = 200): boolean;
begin
  with TfrmGetComment.Create(Application.MainForm) do
    try
      Caption := aCaption;
      lblPrompt.Caption := aPrompt;
      fMin := aMinLen;
      fMax := aMaxLen;
      memComment.MaxLength := fMax;
      memComment.Text := aComment;
      memComment.Hint := Format('Enter a response %d to %d characters.', [fMin, fMax]);
      lblParams.Caption := Format('(%d to %d characters)', [fMin, fMax]);
      if ShowModal = mrOk then
        begin
          Result := True;
          aComment := memComment.Text;
        end
      else
        Result := False;
    finally
      Free;
    end;
end;

procedure TfrmGetComment.memCommentChange(Sender: TObject);
begin
  btnOk.Enabled := (Length(memComment.Text) >= fMin) and (Length(memComment.Text) <= fMax);
  btnOk.Default := btnOk.Enabled;
end;

procedure TfrmGetComment.FormCreate(Sender: TObject);
begin
  lblPrompt.Font.Style := [fsBold];
end;

end.

