unit fLogDisplay;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls, VA508AccessibilityManager;

type
  TfrmLogDisplay = class(TForm)
    memLogDisplay: TMemo;
    btnOK: TButton;
    btnPrint: TButton;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
  private
    fLineNumbers: boolean;
  public
    procedure AddToLog(aLine: string); overload;
    procedure AddToLog(aLines: TStrings); overload;
  end;

function GetLogDisplay(aCaption: string; aLineNumbers: boolean = False; aPrintOK: boolean = False): TfrmLogDisplay;

implementation

{$R *.dfm}

function GetLogDisplay(aCaption: string; aLineNumbers: boolean = False; aPrintOK: boolean = False): TfrmLogDisplay;
begin
  Result := TfrmLogDisplay.Create(Application);
  with Result do
    begin
      Caption := aCaption;
      memLogDisplay.Lines.Clear;
      btnPrint.Visible := aPrintOK;
      fLineNumbers := aLineNumbers;
    end;
end;

procedure TfrmLogDisplay.AddToLog(aLine: string);
begin
  if fLineNumbers then
    memLogDisplay.Lines.Add(Format('%4d. %s', [memLogDisplay.Lines.Count + 1, aLine]))
else
  memLogDisplay.Lines.Add(aLine);
end;

procedure TfrmLogDisplay.AddToLog(aLines: TStrings);
var
  i: integer;
begin
  for i := 0 to aLines.Count - 1 do
    AddToLog(aLines[i]);
end;

end.

