unit fObservationEditor;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 5 $  $Modtime: 2/02/09 9:05a $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Common form for editing a set of observations.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/forms/fObservationEditor.pas $
*
* $History: fObservationEditor.pas $
 * 
 * *****************  Version 5  *****************
 * User: Zzzzzzjuergb Date: 2/02/09    Time: 9:05a
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * 
 * *****************  Version 6  *****************
 * User: Zzzzzzjuergb Date: 1/28/09    Time: 9:29a
 * Updated in $/CP Modernization/CliO/508_source/Common/forms
 * Initial cut
 * 
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 4/25/08    Time: 6:20a
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * 
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 11/24/06   Time: 4:25p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * Implementation of non-modal input in the main form.
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 11/09/06   Time: 3:00p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * Weekly update of all changes.
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:01p
 * Created in $/CP Modernization/CliO/source/Common/forms
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  StdCtrls,
  oInterfaces,
  oCliOTypes,
  oDBController_Observations,
  XMLDoc,
  XMLIntf,
  ActnList,
  ComCtrls, VA508AccessibilityManager;

type
  TOnFileObservations = function(aXMLDocument: IXMLDocument): boolean of object;

  TfrmObservationEditor = class(TForm)
    pnlPtDemo: TPanel;
    lblWardLocationRoomBed: TLabel;
    lblPatientNameSexAge: TLabel;
    lblDOBSSN: TLabel;
    Shape1: TShape;
    imgLogo: TImage;
    vamObservationEditor: TVA508AccessibilityManager;
    procedure acSaveExecute(Sender: TObject);
  private
    fView: IObservationView;
    fPatient: IPatient;
    fUser: IUser;
    fFilename: string;
    fVersion: string;
    fCRCValue: string;
    fOnFileObservations: TOnFileObservations;
    procedure SetOnFileObservations(aFunction: TOnFileObservations);
  public
    function XMLDocument: IXMLDocument;
    procedure SetLocations(aLocationList: TStrings);
    property OnFileObservations: TOnFileObservations read fOnFileObservations write SetOnFileObservations;
  end;

function NewObservationEditorForm(aPatient: IPatient; aUser: IUser; aView: IObservationView): TfrmObservationEditor;

implementation

uses
  oVersionInformation,
  oObservation_View_Term,
  mEditObservationBattery;
//mEditObservationValue;

{$R *.dfm}

function NewObservationEditorForm(aPatient: IPatient; aUser: IUser; aView: IObservationView): TfrmObservationEditor;
(*
var
  aViewTerm: IObservationViewTerm;
  i: integer;
  tt: TTermType;
*)
begin
  Result := TfrmObservationEditor.Create(Application);
  with Result do
    begin
      Font := Application.MainForm.Font;
      Position := poOwnerFormCenter;
      fUser := aUser;
      fPatient := aPatient;
      fView := aView;
      pnlPtDemo.Font.Color := cl3DDkShadow;
      NewEditObservationBatteryFrame(Result, aView, aPatient, aUser);
      (*for tt := High(TTermType) downto Low(TTermType) do
      if tt in TERMQUALIFIERS then
        with TLabel.Create(pnlLabels) do
          begin
            Name := Format('%s_%d', [ClassName, Ord(tt)]);
            Parent := pnlLabels;
            Left := 65 * Ord(tt);
            AutoSize := False;
            Width := 65;
            Align := alRight;
            Caption := QUALNAME[tt];
          end;

    lblPatientNameSexAge.Font.Style := [fsBold];
    lblPatientNameSexAge.Caption := Format('%s - %s (%d)', [aPatient.getName, aPatient.getSex, aPatient.getAge]);
    lblDOBSSN.Caption := FormatDateTime('mmm d, yyyy', aPatient.getDOB) + '  ' + aPatient.getSSN;
    lblWardLocationRoomBed.Caption := Format('Ward: %s  Room/Bed: %s', [aPatient.getWardLocation, aPatient.getRoomBed]);

    edtComment.Text := aView.getComment;
    dtpDateObserved.DateTime := Now;
    dtpTimeObserved.DateTime := Now;

    {Build the source information}
    with TVersionInformation.Create(Application.ExeName) do
      try
        fFilename := ExtractFileName(Application.ExeName);
        fVersion := getFileVersion;
        fCRCValue := getCRC32;
      finally
        Free;
      end;

    aViewTerm := aView.FirstViewTerm;
    while Assigned(aViewTerm) do
      try
        with NewEditObservationValueFrame(scbxForFrames, aViewTerm) do
          begin
            Align := alTop;
            if frac(scbxForFrames.ComponentCount / 2) > 0 then
              Color := clInfoBk;
          end;
      finally
        aViewTerm := aView.NextViewTerm(aViewTerm);
      end;
    *)
    end;
end;

procedure TfrmObservationEditor.SetLocations(aLocationList: TStrings);
begin
  //cbxLocation.Items.Clear;
  //cbxLocation.Items.AddStrings(aLocationList);
end;

procedure TfrmObservationEditor.acSaveExecute(Sender: TObject);
var
  i: integer;
  aXMLDoc: IXMLDocument;
  aNode: IXMLNode;
begin
  aXMLDoc := NewXMLDocument;
  with aXMLDoc do
    begin
      Active := True;
      DocumentElement := AddChild('CLIO');
      DocumentElement.Attributes['TYPE'] := 'FILE_OBSERVATIONS';
      DocumentElement.Attributes['VERSION'] := 'BETA';
      with DocumentElement.AddChild('BATTERY') do
        begin
          (*
          ChildValues['BATTERY_ID'] := NewGUID;
          ChildValues['FACILITY_ID'] := fUser.Station_ID;
          ChildValues['FACILITY_LOCATION_ID'] := cbxLocation.Text;
          ChildValues['PATIENT_ID'] := fPatient.getDFN;
          dtpDateObserved.DateTime := trunc(dtpDateObserved.Date) + Frac(dtpTimeObserved.Time);
          ChildValues['ENTERED_DATE_TIME'] := DateTimeToXMLString(Now);
          ChildValues['ENTERED_BY_ID'] := fUser.DUZ;
          ChildValues['COMMENTS'] := edtComment.Text;
          aNode := AddChild('OBSERVATIONS');
          for i := 0 to scbxForFrames.ComponentCount - 1 do
            if scbxForFrames.Components[i].ClassNameIs('TfraEditObservationValue') then
              with TfraEditObservationValue(scbxForFrames.Components[i]) do
                LoadXML(aNode);
          (*
          for i := 0 to scbxForFrames.ComponentCount - 1 do
            if scbxForFrames.Components[i].ClassNameIs('TfraEditObservation') then
              with TfraEditObservationValue(scbxForFrames.Components[i]) do
                LoadXML(aNode);
          (*
            aNode),
            fPatient.getDFN,
            dtpDateObserved.DateTime,
            fUser.DUZ,
            fView);
          *)
        end;
      SaveToFile('.\AnObservation.xml');
    end;

  {Ok, fire for effect}
  ShowMessage('Check .\AnObservation.xml - these values will not be saved');

  //if fOnFileObservations(aXMLDoc) then
  ModalResult := mrOk;
end;

function TfrmObservationEditor.XMLDocument: IXMLDocument;
begin

end;

procedure TfrmObservationEditor.SetOnFileObservations(aFunction: TOnFileObservations);
begin
  //fOnFileObservations := aFunction;
  //acSave.Enabled := Assigned(aFunction);
end;

end.

