unit fRestrictedRecord;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  StdCtrls;

type
  TfrmRestrictedRecord = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    btnYes: TButton;
    btnNo: TButton;
    stxtHdr1: TStaticText;
    stxtHdr2: TStaticText;
    Memo1: TMemo;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function IsOkayToAccess: boolean;

implementation

uses
  VA508AccessibilityRouter;

{$R *.dfm}

function IsOkayToAccess: boolean;
begin
  with TfrmRestrictedRecord.Create(Application) do
    try
      Memo1.Text :=
        'This record is protected by the Privacy Act of 1974 and the Health Insurance ' +
        'Portability and Accountability Act of 1996. If you elect to proceed, you will ' +
        'be required to prove you have a need to know. Accessing this patient is tracked, ' +
        'and your station Security Officer will contact you for your justification.';
      GetScreenReader.Speak('Warning! ' + Memo1.Text + ' ' + Label1.Caption);
      Result := (ShowModal = mrOK);
    finally
      free;
    end;
end;

procedure TfrmRestrictedRecord.FormCreate(Sender: TObject);
begin
  stxtHdr1.Font.Style := [fsBold];
  stxtHdr2.Font.Style := [fsBold];
end;

procedure TfrmRestrictedRecord.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_Escape then
  MOdalResult := mrCancel;
end;

procedure TfrmRestrictedRecord.FormResize(Sender: TObject);
begin
  btnYes.Left := (Width - (btnYes.Width * 2) - 10) div 2;
  btnNo.Left := btnYes.Left + btnYes.Width + 10;
end;

end.

