unit fSelectDateRange;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 7 $  $Modtime: 10/13/09 11:50a $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Simple Date Range Selector
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/forms/fSelectDateRange.pas $
*
* $History: fSelectDateRange.pas $
 * 
 * *****************  Version 7  *****************
 * User: Zzzzzzjuergb Date: 12/02/09   Time: 2:15p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * 
 * *****************  Version 6  *****************
 * User: Zzzzzzpetitd Date: 3/08/08    Time: 9:48p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * 
 * *****************  Version 5  *****************
 * User: Zzzzzzpetitd Date: 10/13/07   Time: 2:32p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 *
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 9/04/07    Time: 9:59a
 * Updated in $/CP Modernization/CliO/source/Common/forms
 *
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 4/17/07    Time: 8:54a
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * Alpha Readiness Check In.
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 4/03/07    Time: 9:22a
 * Updated in $/CP Modernization/CliO/source/Common/forms
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 3/21/07    Time: 1:54p
 * Created in $/CP Modernization/CliO/source/Common/forms
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:43p
 * Created in $/CP Modernization/CliO/source/ICU Flowsheets
 * Initial Check-In
 *
*
================================================================================
}

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  ComCtrls,
  Buttons,
  ActnList,
  ImgList, System.Actions, System.ImageList;

type
  TRangeSelectOption = (rsoDate, rsoDateTime);

  TfrmSelectDateRange = class(TForm)
    pnlStart: TPanel;
    pnlStop: TPanel;
    pnlOptions: TPanel;
    btnCancel: TButton;
    btnOK: TButton;
    lblStopDate: TLabel;
    lblStartDate: TLabel;
    mcStartDate: TMonthCalendar;
    mcStopDate: TMonthCalendar;
    Bevel2: TBevel;
    Bevel4: TBevel;
    pnlStartTime: TPanel;
    lblStartTime: TLabel;
    Bevel1: TBevel;
    mcStartTime: TDateTimePicker;
    Button1: TButton;
    pnlStopTime: TPanel;
    mcStopTime: TDateTimePicker;
    Button2: TButton;
    lblStopTime: TLabel;
    Bevel3: TBevel;
    ImageList1: TImageList;
    ActionList1: TActionList;
    acPanBack: TAction;
    acExtendBack: TAction;
    acToday: TAction;
    acPanForward: TAction;
    acExtendForward: TAction;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    lblQuickSets: TLabel;
    lblDateDisplay: TLabel;
    acShiftSelector: TAction;
    SpeedButton6: TSpeedButton;
    Shape1: TShape;
    lblHeader: TLabel;
    Shape2: TShape;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CalendarChange(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure acTodayExecute(Sender: TObject);
    procedure acExtendBackExecute(Sender: TObject);
    procedure acPanBackExecute(Sender: TObject);
    procedure acPanForwardExecute(Sender: TObject);
    procedure acExtendForwardExecute(Sender: TObject);
    procedure acShiftSelectorExecute(Sender: TObject);
    procedure pnlStartEnter(Sender: TObject);
  private
    fStartDateTime: TDateTime;
    fStopDateTime: TDateTime;
    fRangeSelectOption: TRangeSelectOption;
    procedure InitDisplay(aOption: TRangeSelectOption);
    { Private declarations }
  public
    { Public declarations }
  end;

function GetDateRange(var aFromDate: TDateTime; var aToDate: TDateTime; aIncludeTime: boolean = false): boolean;

implementation

{$R *.dfm}

uses
  uGlobalVars,
  oCPTypes,
  oDBController_CPConsole,
  fSelectShift;

const
  FORM_DISPLAY_HEIGHT: array[TRangeSelectOption] of integer = (330, 370);
  FORM_DATE_FORMAT: array[TRangeSelectOption] of string = ('MMM D, YY', 'MMM D, YY hh:mm');

function GetDateRange(var aFromDate: TDateTime; var aToDate: TDateTime; aIncludeTime: boolean = false): boolean;
begin
  with TfrmSelectDateRange.Create(Application) do
    try
      fStartDateTime := aFromDate;
      fStopDateTime := aToDate;
      if aIncludeTime then
        fRangeSelectOption := rsoDateTime
      else
        fRangeSelectOption := rsoDate;

      acShiftSelector.Enabled := (MyCPService.CPShiftCount > 0);

      InitDisplay(fRangeSelectOption);

      if ShowModal = mrOK then
        begin
          aFromDate := fStartDateTime;
          aToDate := fStopDateTime;
          Result := True;
        end
      else
        Result := False;
    finally
      Free;
    end;
end;

procedure TfrmSelectDateRange.InitDisplay(aOption: TRangeSelectOption);
begin
  fRangeSelectOption := aOption;
  mcStartDate.Date := fStartDateTime;
  mcStopDate.Date := fStopDateTime;
  mcStartTime.DateTime := fStartDateTime;
  mcStopTime.DateTime := fStopDateTime;

  //lblStartDate.Font.Style := [fsBold];
  //lblStopDate.Font.Style := [fsBold];
  //lblStartTime.Font.Style := [fsBold];
  //lblStopTime.Font.Style := [fsBold];
  lblHeader.Font.Style := [fsBold];
  lblQuickSets.Font.Style := [fsBold];

  pnlStartTime.Visible := (aOption = rsoDateTime);
  pnlStopTime.Visible := (aOption = rsoDateTime);

  CalendarChange(nil);

  Height := FORM_DISPLAY_HEIGHT[aOption];
end;

procedure TfrmSelectDateRange.pnlStartEnter(Sender: TObject);
begin
  mcStartDate.SetFocus;
end;

procedure TfrmSelectDateRange.CalendarChange(Sender: TObject);
begin
  case fRangeSelectOption of
    rsoDate:
      begin
        fStartDateTime := trunc(mcStartDate.Date);
        fStopDateTime := trunc(mcStopDate.Date);
      end;
    rsoDateTime:
      begin
        fStartDateTime := trunc(mcStartDate.Date) + frac(mcStartTime.DateTime);
        fStopDateTime := trunc(mcStopDate.Date) + frac(mcStopTime.DateTime);
      end;
  end;

  btnOk.Enabled := fStartDateTime <= fStopDateTime;
  if btnOk.Enabled then
    begin
      lblDateDisplay.Font.Color := clWindowText;
      lblDateDisplay.Font.Style := [];
      lblDateDisplay.Caption :=
        FormatDateTime(FORM_DATE_FORMAT[fRangeSelectOption], fStartDateTime) +
        ' thru ' +
        FormatDateTime(FORM_DATE_FORMAT[fRangeSelectOption], fStopDateTime);
    end
  else
    begin
      lblDateDisplay.Font.Color := clRed;
      lblDateDisplay.Font.Style := [fsBold];
      lblDateDisplay.Caption := 'Start value must be equal to or less than the Stop value';
    end;
end;

procedure TfrmSelectDateRange.acExtendBackExecute(Sender: TObject);
begin
  mcStartDate.Date := trunc(mcStartDate.Date) - 1;
  CalendarChange(Sender);
end;

procedure TfrmSelectDateRange.acExtendForwardExecute(Sender: TObject);
begin
  mcStopDate.Date := trunc(mcStopDate.Date) + 1;
  CalendarChange(Sender);
end;

procedure TfrmSelectDateRange.acPanBackExecute(Sender: TObject);
begin
  mcStartDate.Date := trunc(mcStartDate.Date) - 1;
  mcStopDate.Date := trunc(mcStopDate.Date) - 1;
  CalendarChange(Sender);
end;

procedure TfrmSelectDateRange.acPanForwardExecute(Sender: TObject);
begin
  mcStartDate.Date := trunc(mcStartDate.Date) + 1;
  mcStopDate.Date := trunc(mcStopDate.Date) + 1;
  CalendarChange(Sender);
end;

procedure TfrmSelectDateRange.acShiftSelectorExecute(Sender: TObject);
begin
  SelectShift(fStartDateTime, fStopDateTime);
  mcStartDate.Date := trunc(fStartDateTime);
  mcStopDate.Date := trunc(fStopDateTime);
  mcStartTime.Time := Frac(fStartDateTime);
  mcStopTime.Time := Frac(fStopDateTime);
end;

procedure TfrmSelectDateRange.acTodayExecute(Sender: TObject);
begin
  mcStartDate.Date := trunc(Now);
  mcStopDate.Date := trunc(Now);
  mcStartTime.DateTime := EncodeTime(0, 0, 0, 0);
  mcStopTime.DateTime := EncodeTime(23, 59, 59, 0);
  CalendarChange(Sender);
end;

procedure TfrmSelectDateRange.btnOKClick(Sender: TObject);
begin
  CalendarChange(Sender);
  if btnOK.Enabled then
    ModalResult := mrOK;
end;

procedure TfrmSelectDateRange.Button1Click(Sender: TObject);
begin
  mcStartTime.DateTime := EncodeTime(0, 0, 0, 0);
  CalendarChange(Sender);
end;

procedure TfrmSelectDateRange.Button2Click(Sender: TObject);
begin
  mcStopTime.DateTime := now;
  CalendarChange(Sender);
end;

end.

