unit fSelectDateTime;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  u508Dialogs,
  ExtCtrls;

type
  TfrmSelectDateTime = class(TForm)
    mc: TMonthCalendar;
    dtpTime: TDateTimePicker;
    lblDate: TLabel;
    lblTime: TLabel;
    btnCancel: TButton;
    btnOK: TButton;
    btnNow: TButton;
    Panel1: TPanel;
    procedure btnNowClick(Sender: TObject);
    procedure dtpTimeExit(Sender: TObject);
  protected
    fDateTime: TDateTime;
  public
    { Public declarations }
  end;

function EditDateTime(var aDateTime: TDateTime; aFieldName: string = ''; aCaption: string = 'Edit Date/Time'): boolean;

implementation

{$R *.dfm}

function EditDateTime(var aDateTime: TDateTime; aFieldName: string = ''; aCaption: string = 'Edit Date/Time'): boolean;
begin
  with TfrmSelectDateTime.Create(Application) do
    try
      lblDate.Font.Style := [fsBold];
      lblDate.Caption := Format('%s Date:', [aFieldName]);
      lblTime.Font.Style := [fsBold];
      lblTime.Caption := Format('%s Time:', [aFieldName]);
      Caption := aCaption;
      mc.Date := aDateTime;
      dtpTime.DateTime := aDateTime;
      if ShowModal = mrOK then
        aDateTime := trunc(mc.Date) + frac(dtpTime.DateTime);
    finally
      Result := (ModalResult = mrOK);
      Free;
    end;
end;

procedure TfrmSelectDateTime.btnNowClick(Sender: TObject);
begin
  mc.Date := Now;
  dtpTime.DateTime := Now;
  ModalResult := mrOk;
end;

procedure TfrmSelectDateTime.dtpTimeExit(Sender: TObject);
var
  dateTime: TDateTime;
begin
  dateTime := Trunc(mc.Date) + Frac(dtpTime.Time);
  if dateTime > now then
  begin
    mc.Date := Now;
    dtpTime.DateTime := Now;
    MessageDlg508('Date/Time selected may not be in the future.', mtError, [mbOK], 0);
  end;
end;

end.

