unit fSelectShift;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  oInterfaces,
  oCPTypes,
  uGlobalVars;

type
  TfrmSelectShift = class(TForm)
    lvShifts: TListView;
    Button1: TButton;
    btnOK: TButton;
    procedure FormCreate(Sender: TObject);
    procedure lvShiftsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure lvShiftsDblClick(Sender: TObject);
  private
    fStartDateTime: TDateTime;
    fStopDateTime: TDateTime;
    fShift: ICPShift;
  public
    { Public declarations }
  end;

function SelectShift(var aStartDateTime: TDateTime; var aStopDateTime: TDateTime): boolean;

implementation

uses
  oDBController_CPConsole,
  DateUtils;

{$R *.dfm}

function SelectShift(var aStartDateTime: TDateTime; var aStopDateTime: TDateTime): boolean;
begin
  with TfrmSelectShift.Create(Application) do
    try
      fStartDateTime := aStartDateTime;
      fStopDateTime := aStopDateTime;
      btnOK.Enabled := False;

      if ShowModal = mrOk then
        begin
          aStartDateTime := fStartDateTime;
          aStopDateTime := fStopDateTime;
          Result := True;
        end
      else
        Result := False;
    finally
      Free;
    end;
end;

procedure TfrmSelectShift.FormCreate(Sender: TObject);
begin
  MyCPService.LoadList(lvShifts, ciShift, True);
end;

procedure TfrmSelectShift.lvShiftsDblClick(Sender: TObject);
begin
  if btnOK.Enabled then
    ModalResult := mrOk;
end;

procedure TfrmSelectShift.lvShiftsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  if Selected then
    begin
      fShift := MyCPService.CPShift(Item.SubItems[2]);
      fStartDateTime := trunc(fStartDateTime) + Frac(fShift.getStartTime);
      fStopDateTime := trunc(fStartDateTime) + Frac(fShift.getStopTime);
      if fShift.getMultiDay then
        fStopDateTime := IncDay(fStopDateTime, 1);
    end;
  btnOk.Enabled := Selected;
end;

end.

