unit fSplash;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 11 $  $Modtime: 11/25/08 11:16a $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Default Splash Screen
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/forms/fSplash.pas $
*
* $History: fSplash.pas $
 * 
 * *****************  Version 11  *****************
 * User: Zzzzzzjuergb Date: 2/06/09    Time: 10:10a
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * Post 508 Merge: with views working in 508 mode and toolbars fixed
 * 
 * *****************  Version 11  *****************
 * User: Zzzzzzjuergb Date: 1/28/09    Time: 9:29a
 * Updated in $/CP Modernization/CliO/508_source/Common/forms
 * Initial cut
 * 
 * *****************  Version 9  *****************
 * User: Zzzzzzandria Date: 7/23/08    Time: 5:54p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * Build 269
 * 
 * *****************  Version 8  *****************
 * User: Zzzzzzpetitd Date: 2/21/08    Time: 1:48p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * 
 * *****************  Version 7  *****************
 * User: Zzzzzzpetitd Date: 10/02/07   Time: 12:53p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * 
 * *****************  Version 6  *****************
 * User: Zzzzzzpetitd Date: 8/31/07    Time: 1:41p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 *
 * *****************  Version 5  *****************
 * User: Zzzzzzpetitd Date: 7/25/07    Time: 12:30p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * Working on the recursive load call so that we can respond back on the
 * progress of the observation loader.
 *
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 5/23/07    Time: 4:32p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 *
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 2/23/07    Time: 1:54p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * Post CMO conference
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 12/15/06   Time: 4:03p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * End of year check-in.
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:03p
 * Created in $/CP Modernization/CliO/source/Common/forms
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  oVersionInformation;

type
  TfrmSplash = class(TForm)
    Panel1: TPanel;
    lblShadow: TLabel;
    lblInset: TLabel;
    Panel2: TPanel;
    lblVersion: TLabel;
    lblDevelopedAt: TLabel;
    lblReleaseDate: TLabel;
    lblpatch: TLabel;
    Image1: TImage;
    lblTestRelease: TLabel;
    lblStatus: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    fVersionInformation: TVersionInformation;
  public
    { Public declarations }
  end;

procedure ShowSplashScreen(aImage: TBitmap = nil);
procedure UpdateSplashScreen(aMessage: string);
procedure HideSplashScreen;
procedure FreeSplashScreen;

var
  frmSplash: TfrmSplash;

implementation

uses
  VA508AccessibilityRouter;

{$R *.DFM}

procedure ShowSplashScreen;
begin
  if frmSplash = nil then
    frmSplash := TfrmSplash.Create(Application);
  frmSplash.Position := poScreenCenter; //zzzzzzandria 20080701
  frmSplash.Image1.Picture.Icon := Application.Icon;
  {
  if Assigned(aImage) then
    begin
      frmSplash.Image1.Picture.Bitmap.Assign(aImage);
      frmSplash.Invalidate;
      Application.ProcessMessages;
    end;
  }
  Application.BringToFront;
  frmSplash.Show;
  GetScreenReader.Speak(frmSplash.lblInset.Caption + ' ' + frmSplash.lblVersion.Caption + ' ' +
    frmSplash.lblReleaseDate.Caption + ' ' + frmSplash.lblPatch.Caption);
  if frmSplash.lblTestRelease.Visible then
    GetScreenReader.Speak('Test Release');
  frmSplash.Invalidate;
  Application.ProcessMessages;
end;

procedure UpdateSplashScreen(aMessage: string);
begin
  if frmSplash <> nil then
    begin
      frmSplash.lblStatus.Caption := Format('%s ...', [aMessage]);
      GetScreenReader.Speak(aMessage);
      frmSplash.Repaint;
      frmSplash.BringToFront;
    end;
end;

procedure HideSplashScreen;
begin
  if frmSplash <> nil then
    frmSplash.Hide;
end;

procedure FreeSplashScreen;
begin
  FreeAndNil(frmSplash);
end;

procedure TfrmSplash.FormCreate(Sender: TObject);
begin
  fVersionInformation := TVersionInformation.Create(Application.ExeName, 'MD');
  panel1.Ctl3D := False;
  lblVersion.Caption := 'Version: ' + fVersionInformation.getVAVersionNumber;
  lblPatch.Caption := 'Patch: ' + fVersionInformation.getVAPatchNumber;
  lblPatch.Visible := (fVersionInformation.getVAPatchNumber <> '');
  lblReleaseDate.Caption := fVersionInformation.getVAReleaseDate;
  lblInset.Caption := fVersionInformation.getProductName;
  lblShadow.Caption := fVersionInformation.getProductName;
  //lblInset.Font.Color := clActiveCaption;
  //lblShadow.Font.Color := cl3DDkShadow;
  //lblShadow.Left := lblInset.Left + 1;
  //lblShadow.Top := lblInset.Top + 1;
  if fVersionInformation.getDebugBuild then
    lblTestRelease.Caption := 'DEBUG BUILD';
  lblTestRelease.Visible := (fVersionInformation.getPreRelease or fVersionInformation.getDebugBuild);
  Position := poDesktopCenter;
  Show;
  Application.ProcessMessages;
end;

procedure TfrmSplash.FormDestroy(Sender: TObject);
begin
  FreeAndNil(fVersionInformation);
end;

end.

