unit oCliOReportColumn;

interface

uses
  oCliOReportWriter,
  Classes,
  SysUtils,
  XMLDoc,
  XMLIntf;

type
  TCliOReportColumn = class(TInterfacedObject, ICliOReportColumn)
  private
    fXMLNode: IXMLNode;
    function getTitle: string; stdcall;
    function getWidth: double; stdcall;
    function getJustification: TCliOReportJustification; stdcall;

    procedure setTitle(aValue: string); stdcall;
    procedure setWidth(aValue: double); stdcall;
    procedure setJustification(aValue: TCliOReportJustification); stdcall;
  public
    constructor Create(aXMLRoot: IXMLNode);
    destructor Destroy; override;
  end;

implementation

{ TCliOReportColumn }

constructor TCliOReportColumn.Create(aXMLRoot: IXMLNode);
begin
  inherited Create;
  fXMLNode := aXMLRoot.AddChild('COLUMN');
  setTitle(Format('Column %d', [aXMLRoot.ChildNodes.Count]));
  setWidth(10);
  setJustification(rjLeft);
end;

destructor TCliOReportColumn.Destroy;
begin
  inherited;
end;

function TCliOReportColumn.getJustification: TCliOReportJustification;
begin
  Result := TCliOReportJustification(fXMLNode.ChildValues['JUSTIFICATION']);
end;

function TCliOReportColumn.getTitle: string;
begin
  Result := fXMLNode.ChildValues['TITLE'];
end;

function TCliOReportColumn.getWidth: double;
begin
  Result := fXMLNode.ChildValues['WIDTH'];
end;

procedure TCliOReportColumn.setJustification(aValue: TCliOReportJustification);
begin
  fXMLNode.ChildValues['JUSTIFICATION'] := aValue;
end;

procedure TCliOReportColumn.setTitle(aValue: string);
begin
  fXMLNode.ChildValues['TITLE'] := aValue;
end;

procedure TCliOReportColumn.setWidth(aValue: double);
begin
  fXMLNode.ChildValues['WIDTH'] := aValue;
end;

end.

