unit oDBConnection_Cache;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 1 $  $Modtime: 11/10/07 12:39p $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Standard Cache ADO Connector for IDBConnection
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/objects/oDBConnection_Cache.pas $
*
* $History: oDBConnection_Cache.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/10/07   Time: 1:16p
 * Created in $/CP Modernization/CliO/source/Common/objects
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:06p
 * Created in $/CP Modernization/CliO/source/Common/objects
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  SysUtils,
  Windows,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  //Dialogs,
  oInterfaces,
  oDBConnection_ADO;

type
  TDBConnection_Cache = class (TDBConnection_ADO, IDBConnection)
  private
    fConnectionString: string;
    fDatabase: string;
    fPort: Integer;
    fServer: string;
  public
    constructor Create;
    destructor Destroy; override;
    function Connect(aParams: array of variant): Boolean; stdcall;
    function getDescription: string; stdcall;
  end;
  
implementation

const
  CONN_STR = 'Provider=MSDASQL.1;Persist Security Info=False;Extended Properties="DSN=CLIO;SERVER=%s;PORT=%d;DATABASE=%s;UID=_system;"';
  //CONN_STR = 'DSN=CLIO;SERVER=127.0.0.1;PORT=1972;DATABASE=CLIO;UID=_system;PWD=sys';
  //CONN_STR = 'DSN=CLIO;SERVER=%s;PORT=%d;DATABASE=%s;UID=_system;PWD=sys';


{
************************************************* TDBConnection_Cache **************************************************
}
constructor TDBConnection_Cache.Create;
begin
  inherited Create;
end;

destructor TDBConnection_Cache.Destroy;
begin
  inherited;
end;

function TDBConnection_Cache.Connect(aParams: array of variant): Boolean;
begin
  fServer := aParams[0];
  fPort := aParams[1];
  fDatabase := aParams[2];
  fConnectionString := Format(CONN_STR, [fServer, fPort, fDatabase]);
  Result := ConnectADO(fConnectionString);
end;

function TDBConnection_Cache.getDescription: string;
begin
  Result := Format('Cache SQL (Server=%s Port=%d DB=%s)', [fServer, fPort, fDatabase]);
end;

end.

