unit oObservation_Correction;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 2 $  $Modtime: 4/08/08 9:58a $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Observation Correction
*
*       Notes:        NOT YET DEFINED - DO NOT USE YET.
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/objects/oObservation_Correction.pas $
*
* $History: oObservation_Correction.pas $
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 4/08/08    Time: 8:14p
 * Updated in $/CP Modernization/CliO/source/Common/objects
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:10p
 * Created in $/CP Modernization/CliO/source/Common/objects
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  SysUtils,
  oInterfaces;

type
  TObservationCorrectionType = (ctRescissionWithReplacement, ctRescissionWithoutReplacement);

  TObservation_Correction = class (TInterfacedObject)
  private
    fComments: string;
    fCorrectionByID: string;
    fCorrectionDateTime: TDateTime;
    fCorrectionID: string;
    fCorrectionType: TObservationCorrectionType;
    fObservationID: string;
  public
    constructor Create;
    destructor Destroy; override;
    function getComments: string;
    function getCorrectionByID: string;
    function getCorrectionDateTime: TDateTime;
    function getCorrectionID: string;
    function getCorrectionType: TObservationCorrectionType;
    function getObservationID: string;
    procedure setComments(aValue: string);
    procedure setCorrectionByID(aValue: string);
    procedure setCorrectionDateTime(aValue: TDateTime);
    procedure setCorrectionID(aValue: string);
    procedure setCorrectionType(aValue: TObservationCorrectionType);
    procedure setObservationID(aValue: string);
  end;
  
function NewObservationCorrection: TObservation_Correction;

implementation

function NewObservationCorrection: TObservation_Correction;
begin
  Result := TObservation_Correction.Create;
end;

{ TObservation_Correction }

{
*********************************************** TObservation_Correction ************************************************
}
constructor TObservation_Correction.Create;
begin
  inherited;
end;

destructor TObservation_Correction.Destroy;
begin
  inherited;
end;

function TObservation_Correction.getComments: string;
begin
  Result := fComments;
end;

function TObservation_Correction.getCorrectionByID: string;
begin
  Result := fCorrectionByID;
end;

function TObservation_Correction.getCorrectionDateTime: TDateTime;
begin
  Result := fCorrectionDateTime;
end;

function TObservation_Correction.getCorrectionID: string;
begin
  Result := fCorrectionID;
end;

function TObservation_Correction.getCorrectionType: TObservationCorrectionType;
begin
  Result := fCorrectionType;
end;

function TObservation_Correction.getObservationID: string;
begin
  Result := fObservationID;
end;

procedure TObservation_Correction.setComments(aValue: string);
begin
  fComments := aValue;
end;

procedure TObservation_Correction.setCorrectionByID(aValue: string);
begin
  fCorrectionByID := aValue;
end;

procedure TObservation_Correction.setCorrectionDateTime(aValue: TDateTime);
begin
  fCorrectionDateTime := aValue;
end;

procedure TObservation_Correction.setCorrectionID(aValue: string);
begin
  fCorrectionID := aValue;
end;

procedure TObservation_Correction.setCorrectionType(aValue: TObservationCorrectionType);
begin
  fCorrectionType := aValue;
end;

procedure TObservation_Correction.setObservationID(aValue: string);
begin
  fObservationID := aValue;
end;

end.

