unit oObservation_Documentor;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 2 $  $Modtime: 5/22/09 1:24p $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Observation Documentor
*
*       Notes:        NOT YET DEFINED - DO NOT USE YET.
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/objects/oObservation_Documentor.pas $
*
* $History: oObservation_Documentor.pas $
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzjuergb Date: 5/22/09    Time: 2:17p
 * Updated in $/CP Modernization/CliO/source/Common/objects
 * Build Pre-275:  
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:10p
 * Created in $/CP Modernization/CliO/source/Common/objects
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Classes,
  oInterfaces,
  oObservation_Battery,
  oObservation;

type
  TObservationDocumentType = (dtText, dtHTML, dtXML, dtPDF);

  TObservation_Documentor = class (TObject)
  private
    fCollectionOfObjects: TStringList;
    fDocumentType: TObservationDocumentType;
    fOutput: TStringList;
  public
    constructor Create;
    destructor Destroy; override;
    procedure addBattery(aBattery: TObservation_Battery);
    procedure addObservation(aHeading: string; aObservation: TObservation);
    function Execute: Boolean;
    function getDocument: string;
    procedure setDocumentType(aDocumentType: TObservationDocumentType);
  end;
  
implementation

uses
  SysUtils,
  XMLDoc,
  XMLIntf;

const
  DASH_LINE = '--------------------------------------------------------------------------------';

{ TObservation_Documentor }


{
*********************************************** TObservation_Documentor ************************************************
}
constructor TObservation_Documentor.Create;
begin
  inherited;
  fCollectionOfObjects := TStringList.Create;
  fOutput := TStringList.Create;
  fDocumentType := dtText;
end;

destructor TObservation_Documentor.Destroy;
begin
  FreeAndNil(fCollectionOfObjects);
  FreeAndNil(fOutput);
  inherited;
end;

procedure TObservation_Documentor.addBattery(aBattery: TObservation_Battery);
begin
  //fCollectionOfObjects.AddObject(aBattery.getID, aBattery);
end;

procedure TObservation_Documentor.addObservation(aHeading: string; aObservation: TObservation);
begin
  fCollectionOfObjects.AddObject(aHeading, aObservation)
end;

function TObservation_Documentor.Execute: Boolean;
var
  i: Integer;
  aDocumentor: IDocumentor;
  aDocument: IXMLDocument;
begin
  result := false;
  fOutput.Clear;
  case fDocumentType of
    dtText:
      begin
        for i := 0 to fCollectionOfObjects.Count - 1 do
          if fCollectionOfObjects.Objects[i].GetInterface(IDocumentor, aDocumentor) then
            fOutput.add(aDocumentor.getText);
        result := true;
      end;
    dtHTML:
      begin
        aDocument := NewXMLDocument;
        aDocument.DocumentElement := aDocument.AddChild('HTML');
        for i := 0 to fCollectionOfObjects.Count - 1 do
          if fCollectionOfObjects.Objects[i].GetInterface(IDocumentor, aDocumentor) then
            aDocumentor.getHTML(aDocument);
        fOutput.Text := aDocument.XML.Text;
        result := true;
      end;
  end;
end;

function TObservation_Documentor.getDocument: string;
begin
  Result := fOutput.Text;
end;

procedure TObservation_Documentor.setDocumentType(aDocumentType: TObservationDocumentType);
begin
  fDocumentType := aDocumentType;
end;

end.

