unit oObservation_Validator;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 4 $  $Modtime: 5/22/09 10:58a $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Validates observations.
*
*       Notes:        Historical - not for use at this time.
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/objects/oObservation_Validator.pas $
*
* $History: oObservation_Validator.pas $
 * 
 * *****************  Version 4  *****************
 * User: Zzzzzzjuergb Date: 5/22/09    Time: 2:17p
 * Updated in $/CP Modernization/CliO/source/Common/objects
 * Build Pre-275:  
 * 
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 4/10/07    Time: 3:30p
 * Updated in $/CP Modernization/CliO/source/Common/objects
 * Revamp of terminology to all interfaces.
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 2/23/07    Time: 1:55p
 * Updated in $/CP Modernization/CliO/source/Common/objects
 * Post CMO conference
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:11p
 * Created in $/CP Modernization/CliO/source/Common/objects
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Classes,
  oCliOTypes,
  oInterfaces,
  oObservation;

type
  TObservation_Validator = class(TObject)
  private
    fErrorLog: TStringList;
    //fTerminology: ITerminology;
  public
    constructor Create;
    destructor Destroy; override;
    function Clear: Boolean;
    function getErrorCount: Integer;
    function getErrorLog: string;
    function getErrorMessage(aObservation: TObservation): string;
    function IsObservationValid(aObservation: TObservation; aIgnoreBlankValues: Boolean = True): Boolean;
  end;

implementation

uses
  SysUtils,
  Variants;

{ TObservationValidator }

{
************************************************ TObservation_Validator ************************************************
}

constructor TObservation_Validator.Create;
begin
  inherited Create;
  fErrorLog := TStringList.Create;
end;

destructor TObservation_Validator.Destroy;
begin
  FreeAndNil(fErrorLog);
  inherited;
end;

function TObservation_Validator.Clear: Boolean;
begin
  fErrorLog.Clear;
  result := true;
end;

function TObservation_Validator.getErrorCount: Integer;
begin
  Result := fErrorLog.Count;
end;

function TObservation_Validator.getErrorLog: string;
var
  i: Integer;
begin
  Result := 'Validation Error Log:' + #13 + 'Errors found: ' + IntToStr(fErrorLog.Count) + #13;
  for i := 0 to fErrorLog.Count - 1 do
    Result := Result + Format('%d. %s', [i + 1, fErrorLog.ValueFromIndex[i]]) + #13;
end;

function TObservation_Validator.getErrorMessage(aObservation: TObservation): string;
begin
  Result := ''; //fErrorLog.Values[aObservation.ID];
end;

function TObservation_Validator.IsObservationValid(aObservation: TObservation; aIgnoreBlankValues: Boolean = True):
  Boolean;
begin
  {
  i := fErrorLog.IndexOfName(aObservation.getID);
  if i > -1 then
    fErrorLog.Delete(i);
  }
  {Is there even a value here?}
  //if (VarToStrDef(aObservation.SValue, '') = '') and (aObservation.Complex_Observation_Count = 0) then
  (*
  if aObservation.IsObservationBlank then
    if aIgnoreBlankValues then
      begin
        Result := True;
        Exit;
      end
    else
      begin
        fErrorLog.Values[aObservation.ID] := 'Missing Data';
        Result := False;
        Exit;
      end;

  if (aObservation.UnitOfMeasure = nil) and (aObservation.Term.getDataType <> dtNumeric) then
    begin
      Result := True;
      Exit;
    end;

  {Here's the checking}
  { TODO 5 -oDanP -cGotta Do It! : Add the data checks here. }
  Errors := TStringList.Create;
  if aObservation.Complex_Observation_Count = 0 then
    begin
      if VarToStr(aObservation.SValue) = '' then
        Errors.Add('Blank values not allowed');
      if aObservation.Term.getDataType = dtNumeric then
        try
          if aObservation.UnitOfMeasure = nil then
            Errors.Add(
              'Invalid Value for ' + aObservation.Term.getTerm + #13 +
              #9 + 'A unit must be assigned to validate.')
          else
            if not aObservation.Term.Validate(aObservation.UnitOfMeasure, aObservation.SValue) then
              Errors.Add(
                'Invalid Value for ' + aObservation.Term.getDisplayName + #13 +
                #9 + aObservation.Term.getHelpText(aObservation.UnitOfMeasure));
        except
          on E: EVariantTypeCastError do
            Errors.Add(
              'Invalid Value for ' + aObservation.Term.getTerm + #13 +
              #9 + 'A numeric value and a unit must be assigned to validate.');
        else
          raise;
        end
    end
  else
    begin
      for i := 0 to aObservation.Complex_Observation_Count - 1 do
        if not IsObservationValid(aObservation.Complex_Observation(i)) then
          Errors.Add(
            'Error in complex observation ' +
            fErrorLog.Values[aObservation.Complex_Observation(i).ID]);
    end;

  if Errors.Count = 0 then
    Result := True
  else
    begin
      fErrorLog.Values[aObservation.ID] := Errors.Text;
      Result := False;
    end;
  *)
  result := true;
end;

end.

