unit oTerminology_Exporter;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TTerminology_Exporter = class (TObject)
  private
    fDBConnection: IDBConnection;
    fListOfTerms: TStringList;
  public
    function Execute(aFilename: string): Boolean;
  end;
  

procedure Register;

implementation

procedure Register;
begin
end;

{
************************************************ TTerminology_Exporter *************************************************
}
function TTerminology_Exporter.Execute(aFilename: string): Boolean;
var
  i: Integer;
  aTerm: TTerm;
  aTermRoot: IXMLNode;
  aChildRoot: IXMLNode;
  aQualRoot: IXMLNode;
  aUnitRoot: IXMLNode;
  aPickListRoot: IXMLNode;
begin
  with NewXMLDocument do
    begin
      Active := True;
      DocumentElement := AddChild('TERMINOLOGY');
  
      with DocumentElement.AddChild('DESCRIPTION') do
        begin
          ChildValues['ID'] := NewGUID;
          ChildValues['DT_CREATED'] := DateTimeToStr(Now);
          ChildValues['DB_NAME'] := fDBConnection.getDescription;
          ChildValues['TERMINOLOGY_VERSION'] := TERMINOLOGY_VERSION;
          ChildValues['TERMS_EXPORTED'] := fListOfTerms.Count;
        end;
  
      {Build the roots in the document}
      aTermRoot := DocumentElement.AddChild('TERMS');
      aChildRoot := DocumentElement.AddChild('CHILD_PAIRS');
      aQualRoot := DocumentElement.AddChild('QUALIFIER_PAIRS');
      aUnitRoot := DocumentElement.AddChild('UNIT_PAIRS');
      aPickListRoot := DocumentElement.AddChild('PICKLIST_PAIRS');
  
      for i := 0 to fListOfTerms.Count - 1 do
        begin
          aTerm := TTerm(fListOfTerms.Objects[i]);
          aTerm.ExportTerm(aTermRoot);            {add to the term list}
          aTerm.ExportPairs(aChildRoot);          {add the child terms}
          aTerm.ExportQualifiers(aQualRoot);      {add the qualifiers}
          aTerm.ExportUnits(aUnitRoot);           {add the units}
          aTerm.ExportPickList(aPickListRoot);    {add picklist values}
        end;
  
      SaveToFile(aFileName);
    end;
end;


end.
