unit u508Func;

interface

uses
  oInterfaces;

function GetVerbalSSN(ASSN: string): string;
function GetVerbalDate(ADate: string): string;
function GetVerbalPID(APatient: IPatient): string;

implementation

uses
  SysUtils,
  Controls;

const
  SENSITIVE = '*SENSITIVE*';


function GetVerbalSSN(ASSN: string): string;
var
  I: Integer;
begin
  if StrComp(pChar(ASSN), pChar(SENSITIVE)) = 0 then
    result := 'Sensitive'
  else
  begin
    result := '';
    for I := 1 to Length(ASSN) do
    begin
      result := result + ASSN[I] + ' ';
    end;
  end;
end;

function GetVerbalDate(ADate: string): string;
var
  DOB: TDate;
  Year,
  Month,
  Day: word;
begin
  if StrComp(pChar(ADate), pChar(SENSITIVE)) = 0 then
    result := 'Sensitive'
  else
  begin
    Year := StrToIntDef(copy(ADate, 7, 4), 0);
    Month := StrToIntDef(copy(ADate, 1, 2), 0);
    Day := StrToIntDef(copy(ADate, 4,2 ), 0);
    DOB := EncodeDate(Year, Month, Day);
    result := FormatDateTime('mmmm dd, yyyy', DOB);
  end;
end;

function GetVerbalPID(APatient: IPatient): string;
begin
  if Assigned(APatient) then
  begin
    result :=
      'name ' +
      APatient.getName + ' ' +
      's s n ' +
      GetVerbalSSN(APatient.getSSN) +
      'd o b ' +
      GetVerbalDate(APatient.getDateOfBirth); 
  end;
end;

end.
